UNIT Algemeen;
{$D+}

                                INTERFACE

USES

  Crt,
  Dos,
  Graph;


TYPE

  PString = ^String;

FUNCTION VraagJaNee(tekst : string; voorkeur : boolean) : boolean;
FUNCTION VraagInteger(tekst : String; van, tot : Integer) : Integer;
FUNCTION Driesprong(tekst, keuze1, keuze2, keuze3 : string; voorkeur : byte) : byte;
FUNCTION DirExists(dir : dirstr) : boolean;
FUNCTION FileExists(pad : pathstr) : boolean;
FUNCTION DestilleerDir(pad : pathstr) : dirstr;
FUNCTION DatumStr : string;
FUNCTION HeapFunc(Size: word): Integer;


VAR

  TekstVoordiagram  : pathstr;
  TekstNaDiagram    : pathstr;
  TekstVoorDocument : pathstr;
  TekstNaDocument   : pathstr;
  EersteDiagram     : boolean;
  EersteProgramma   : boolean;
  programmahoofding : string;


CONST

   genereerTekstVoorDiagram = 'NAAM KLAS OEFENING';
   genereerTekstNaDiagram = 'NS - DIAGRAM';
   geenTekstVoorDocument = '';
   geenTekstNaDocument = '';


                                IMPLEMENTATION


FUNCTION FileExists(pad : pathstr) : boolean;

  var

    rommelrec : searchrec;

  begin

    if (pos('*',pad)=0) and (pos('?',pad)=0) then
       begin
       findfirst(pad,archive,rommelrec);
       if doserror=0 then
          begin
          FileExists:=true;
          exit;
          end;
       end;
    FileExists:=false;

  end;


FUNCTION DatumStr : string;

  CONST

    days : array [0..6] of String[9] =('Zondag','Maandag','Dinsdag',
                                       'Woensdag','Donderdag','Vrijdag',
                                       'Zaterdag');

  VAR

    Y, M, D, DOW : Word;

  FUNCTION NaarStr(waarde : word) : string;

    var

      str : string;

    begin

      system.str(waarde,str);
      Naarstr:=str;

    end;


  BEGIN

    GetDate(y,m,d,dow);
    DatumStr:=days[dow]+', '+Naarstr(d)+ '/'+Naarstr(m)+'/'+naarstr(y);

  end;


FUNCTION DestilleerDir(pad : pathstr) : dirstr;

  var

    N : NameStr;
    E : ExtStr;
    D : DirStr;

  begin

    if (Pos('*',pad)<>0) or (Pos('?',pad)<>0) then
       begin
       Fsplit(Pad,D,N,E);
       DestilleerDir:=D;
       end else destilleerdir:=pad;

  end;


FUNCTION Driesprong(tekst, keuze1, keuze2, keuze3 : string; voorkeur : byte) : byte;

  var

    stop : boolean;
    eerstekeer : boolean;
    start : byte;
    PijlLeft : char;
    PijlRight : char;
    keuze     : byte;


  procedure ZetPijl;

     begin

       PijlLeft:=#16;
       PijlRight:=#17;

     end;


  procedure ClearPijl;

    begin

      Pijlleft:=' ';
      PijlRight:=' ';

    end;


  begin

    Writeln(tekst);
    keuze:=voorkeur;
    eerstekeer:=true;
    stop:=false;
    repeat
      if not eerstekeer then gotoxy(1,start);
      if keuze=1 then ZetPijl else clearpijl;
      writeln('      ',pijlLeft,' 1. ',keuze1,' ',pijlRight);
      if keuze=2 then ZetPijl else clearpijl;
      writeln('      ',pijlLeft,' 2. ',keuze2,' ',pijlright);
      if keuze=3 then ZetPijl else clearpijl;
      writeln('      ',pijlLeft,' 3. ',Keuze3,' ',pijlRight);
      case readkey of
        #13 : stop:=true;
        #27 : ;
        '1' : keuze:=1;
        '2' : keuze:=2;
        '3' : keuze:=3;
        #0  : begin
              case readkey of
                #72 : begin
                      keuze:=keuze-1;
                      if keuze=0 then keuze:=3;
                      end;
                #80 : begin
                      keuze:=keuze+1;
                      if keuze>3 then keuze:=1;
                      end;
                end;
              end;
        end;
      start:=whereY-3;
      eerstekeer:=false;
    until stop;
    Driesprong:=keuze;
    GotoXY(1,start+3);

  end;


FUNCTION DirExists(dir : dirstr) : boolean;

  var

    rommelrec : searchrec;

  begin

    if dir[length(dir)]='\' then dir[0]:=chr(ord(dir[0])-1);
    Findfirst(dir,directory,rommelrec);
    if doserror<>0 then DirExists:=false else direxists:=true;

  end;


FUNCTION VraagJaNee(Tekst : string; voorkeur : boolean) : boolean;

  var

    X : byte;
    Y : byte;
    stop : boolean;
    keuze : boolean;

  begin

    Write(Tekst);
    X:=WhereX;
    Y:=WhereY;
    stop:=false;
    keuze:=voorkeur;
    repeat
      gotoxy(X,Y);
      if keuze then write('Ja ') else write('Nee');
      case readkey of
        #13 : stop:=true;
        #27 : ;
        #0  : begin
              if readkey='' then ;
              keuze:=not(keuze);
              end;
        else
          begin
          keuze:=not keuze;
          end;
        end;
    until stop;
    writeln;
    VraagJaNee:=keuze;

  end;


{$F+}
FUNCTION HeapFunc(Size: word): Integer;

  BEGIN

    if size<>0 then
       begin
       closegraph;
       Writeln('Je programma neemt me net iets te veel geheugen, sorry ...');
       halt;
       end;

  END;
{$F-}


FUNCTION VraagInteger(tekst : String; van, tot : Integer) : Integer;

  var

    fout : Integer;
    invoerString : String;
    waarde : Integer;
    gadoor : Boolean;

  BEGIN

    REPEAT
      GaDoor:=true;
      Write(tekst);
      Readln(invoerString);
      val(invoerString,waarde,fout);
      IF fout<>0 THEN
        BEGIN
        Writeln('Je doet iets fout !');
        Gadoor:=false;
        waarde:=van;
        END;
      IF not((waarde>=van) and (waarde<=tot)) THEN
        BEGIN
        Writeln('Het getal moet tussen ',van,' en ',tot,' liggen !');
        Gadoor:=false;
        END;
    UNTIL gadoor;
    vraaginteger:=waarde;

  END;


BEGIN

  TekstVoorDiagram:=genereerTekstVoorDiagram;
  TekstNaDiagram:=genereerTekstNaDiagram;
  TekstVoorDocument:=geenTekstVoorDocument;
  TekstNaDocument:=geenTekstNaDocument;
  Eerstediagram:=true;
  ProgrammaHoofding:='';
  EersteProgramma:=true;
  HeapError:=@Heapfunc;

END.
