UNIT FileList;
{$D-}

                            INTERFACE

USES

  Dos;


CONST

  NoRecurse = false;
  Recurse   = true;


TYPE

  TFileList = OBJECT
                Pad          : pathstr;
                jaar         : word;
                maand        : word;
                dag          : word;
                uur          : word;
                minuut       : word;
                second       : word;
                attribuut    : word;
                grootte      : longint;
                AantalFiles  : word;
                LaatsteFile  : boolean;
                constructor  Reset(Sourcepad : pathstr; recurse: boolean);
                procedure    NextFile; virtual;
              private
                SR           : searchrec;
                diepte       : word;
                Recursie     : boolean;
                HuidigPad    : pathstr;
                opgegevenPad : pathstr;
                opNaam       : namestr;
                opExt        : extstr;
                nogmaals     : boolean;
                FileReeks    : string;
                Filenummer   : word;
                arraySR      : Array[1..32] of SearchRec;
                function     ChkStr(variabele, controle : string) : boolean;
                function     hoofdletters (str : string) : string;
                FUNCTION     IsDirectory(Path : pathstr) : boolean;
                function     NaamVoldoet(name : string) : boolean;
                FUNCTION     NoJokers(str : string) : boolean;
                Function     VeranderNaam(SourcePad : PathStr; Srecord : SearchRec) : PathStr;
                procedure    FindNext(var ImSR : SearchRec);
                procedure    GelijkeLengte(var str1,str2 : string);
                procedure    HaalDirWeg;
                Procedure    HaalInformatie;
                procedure    HaalTerug(var nummer : word);
                procedure    Onthoud (nummer : word);
                Procedure    VoegToe(var str : string; aantal : byte);
                procedure    voerDirIn (naam : string);
              end;
  TarchiveFileList = object(TFileList)
                  constructor reset(sourcepad : pathstr; rec : boolean);
                  procedure NextFile; virtual;
                  procedure controle; virtual;
                  end;



                        IMPLEMENTATION


PROCEDURE TFileList.NextFile;

  begin
    repeat
      HaalInformatie;
    until not nogmaals;
  end;


constructor TFileList.Reset(Sourcepad : pathstr; recurse : boolean);

  var

    D : dirstr;
    N : nameStr;
    E : extstr;
    Naam : string;
    error : longint;
    rommelrec : searchrec;
    tempPad   : Pathstr;

  begin

    SourcePad:=hoofdletters(Sourcepad);
    FSplit(Sourcepad,D,N,E);
    if length(D)=0 then GetDir(0,D);
    if (D[2]=':') and (length(D)=2) then
      begin
      GetDir(ord(D[1])-64,D);
      error:=diskfree(ord(D[1])-64);
      if error=-1 then
         begin
         laatstefile:=true;
         AantalFiles:=0;
         exit;
         end;
      end;
    if D[length(D)]<>'\' then D:=D+'\';
    Naam:=N+E;
    temppad:=D+Naam;
    if noJokers(Naam) and IsDirectory(tempPad) then
       begin
       D:=D+Naam+'\';
       N:='*';
       E:='.*';
       end;
    if N='' then N:='*';
    if E='' then E:='.*'; 
    OpgegevenPad:=D+'*.*';
    opNaam:=N;
    opExt:=copy(E,2,3);
    Huidigpad:=OpgegevenPad;
    Recursie:=recurse;
    laatstefile:=false;
    AantalFiles:=0;
    Filenummer:=0;
    FileReeks:=#0#0;
    diepte:=0;
    SR.Name:='';
    NextFile;

  end;


FUNCTION TFileList.ChkStr(variabele, controle : string) : boolean;

  var

    positie : byte;
    resultaat : boolean;
    stopmaar : boolean;

  begin

    positie:=0;
    stopmaar:=false;
    resultaat:=true;
    GelijkeLengte(controle,variabele);
    repeat
      positie:=positie+1;
      if (positie>length(variabele)) or (controle[positie]='*') then stopmaar:=true else
        begin
        if controle[positie]<>'?' then
          begin
          if controle[positie]<>variabele[positie] then resultaat:=false;
          end;
        end;
    until stopmaar or not resultaat;
    chkstr:=resultaat;

  end;


FUNCTION TFileList.Hoofdletters(str : string) : string;

  var

    tekennummer : byte;

  begin

    if length(str)> 0 then
    for tekennummer:=1 to length(str) do
    str[tekennummer]:=upcase(str[tekennummer]);
    Hoofdletters:=str;

  end;


FUNCTION TFileList.IsDirectory(Path : pathstr) : boolean;

  var

    rommelrec : searchrec;

  begin

    FindFirst(Path,Anyfile,rommelrec);
    if doserror=0 then
      begin
      if rommelrec.attr=directory then isdirectory:=true else isdirectory:=false;
      end
      else IsDirectory:=false;

  end;


FUNCTION TFileList.NaamVoldoet(Name : string) : boolean;

  var

    Deel1   : NameStr;
    Deel2   : ExtStr;
    rommel  : DirStr;

  begin

    FSplit(Name,Rommel,Deel1,Deel2);
    if length(Deel2)>1 then Deel2:=copy(deel2,2,3);
    NaamVolDoet:=chkStr(Deel1,opNaam) and chkstr(Deel2,opExt);

  end;


FUNCTION TFileList.NoJokers(str : string) : boolean;

  const

    jokerset = ['*', '?'];

  VAR

    teller : byte;

  begin

    if length(str)=0 then begin nojokers:=false; exit; end;
    nojokers:=true;
    for teller:=1 to length(str) do if str[teller] in jokerset then nojokers:=false;

  end;


FUNCTION TFileList.VeranderNaam(SourcePad : pathstr; SRecord : searchrec) : pathstr;

  var

    D : dirstr;
    N : NameStr;
    E : ExtStr;

  begin

    FSplit(SourcePad,D,N,E);
    verandernaam:=D+hoofdletters(SRecord.Name);

  end;


PROCEDURE TFileList.FindNext(var ImSR : SearchRec);

  begin

    repeat
      Dos.FindNext(ImSR);
    until ((ImSR.Attr=directory) and recursie) or
          NaamVoldoet(ImSR.Name) or
          (doserror<>0);

  end;


PROCEDURE TFileList.GelijkeLengte(var str1, str2 : string);

  var

    lengte1 : byte;
    lengte2 : byte;

  begin

    lengte1:=length(str1);
    lengte2:=length(str2);
    if lengte1=lengte2 then exit;
    if lengte1>lengte2 then begin VoegToe(str2,lengte1-lengte2); exit; end
    else  if lengte1<lengte2 then VoegToe(str1,lengte2-lengte1);

  end;


PROCEDURE TFileList.HaalDirWeg;

  var

    D1 : DirStr;        D2 : DirStr;
    N1 : NameStr;       N2 : NameStr;
    E1 : ExtStr;        E2 : ExtStr;

  begin

    FSplit(Huidigpad,D1,N1,E1);
    D1[0]:=chr(length(D1)-1);
    Fsplit(D1,D2,N2,E2);
    Huidigpad:=D2+N1+E1;
    SR:=ArraySR[diepte];

  end;


PROCEDURE TFileList.HaalInformatie;

  var

    Datime : DateTime;
    RommelRec : SearchRec;

  begin

    Rommelrec.Name:='';
    nogmaals:=false;
    if Filenummer=0 then FindFirst(HuidigPad,anyfile,SR) else
       begin
       findfirst(huidigpad,anyfile,RommelRec);
       findnext(SR);
       end;
    filenummer:=filenummer+1;
    if (doserror<>18) and (doserror<>0) then
       begin
       Laatstefile:=true;
       exit;
       end;
    if doserror=18 then
         begin
         if diepte=0 then begin laatstefile:=true; exit; end else
           begin
           HaalDirWeg;
           findfirst(huidigpad,anyfile,rommelrec);
           HaalTerug(FileNummer);
           Diepte:=diepte-1;
           nogmaals:=true;
           end;
         end
       else
         if (SR.Attr=directory) and ((SR.Name='.') or (SR.Name='..')) then nogmaals:=true else
         begin
         if naamvoldoet(SR.Name) or ((SR.attr=directory) and recursie) then
           begin
           attribuut:=SR.Attr;
           grootte:=SR.Size;
           unpacktime(SR.time,datime);
           with datime do
             begin
             second:=sec;
             minuut:=min;
             uur:=hour;
             jaar:=year;
             maand:=month;
             dag:=day;
             end;
           pad:=VeranderNaam(huidigpad,SR);
           if recursie and (attribuut=Directory) and (SR.Name<>'.') and (SR.Name<>'..') then
              begin
              Diepte:=diepte+1;
              VoerDirIn(SR.Name);
              Onthoud(FileNummer);
              Filenummer:=0;
              nogmaals:=true;
              end else AantalFiles:=Aantalfiles+1;
           end else Nogmaals:=true;
         end;

  end;


PROCEDURE TFileList.HaalTerug(var nummer : word);

  begin

    nummer:=ord(FileReeks[(length(filereeks)-1)])*256+
            ord(filereeks[length(filereeks)]);
    FileReeks[0]:=chr(length(filereeks)-2);

  end;


PROCEDURE TFileList.Onthoud (nummer : word);

  begin

    FileReeks:=FileReeks+chr(HI(Nummer))+chr(LO(Nummer));
    ArraySR[diepte]:=SR;

  end;


PROCEDURE TFileList.VoerDirIn(Naam : string);

  var

    D : DirStr;
    N : NameStr;
    E : ExtStr;

  begin

    FSplit(Huidigpad,D,N,E);
    D:=D+Naam+'\';
    Huidigpad:=D+N+E;

  end;


PROCEDURE TFileList.VoegToe(var str : string; aantal : byte);

  var

    tempstr : string;
    teller  : byte;

  begin

    tempstr:='';
    for teller:=1 to aantal do tempstr:=tempstr+' ';
    str:=str+tempstr;

  end;


constructor TarchiveFileList.reset(sourcepad : pathstr; rec : boolean);

  begin

    TFileList.Reset(sourcepad, rec);
    Controle;

  end;


procedure TarchiveFileList.nextfile;

  begin

    TFileList.NextFile;
    Controle;

  end;


procedure TarchiveFileList.controle;

  begin

    while ((attribuut and not(archive))<>0) and not(laatstefile) do
      begin
      aantalfiles:=aantalfiles-1;
      TFileList.nextfile;
      end;

  end;

END.
