UNIT Font;
{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,R-,S+,V+,X+}
{$M 16384,0,655360}

                                INTERFACE

USES

  app,
  dos,
  menus,
  Views,
  printer,
  msgBox2,
  Dialogs,
  Drivers,
  StdDlg2,
  Objects,
  P2NHelp,
  P2ninst2;

TYPE

  PPrintBuffer = ^TPrintBuffer;
  TPrintBuffer = array[1..1920] of byte;
  PPrintData = ^TPrintData;
  TPrintData = record
               Keuze : word;
               Tekst : string[240];
               end;
  PScrollAscii = ^TScrollAscii;
  TScrollAscii = object(TView)
                 teken : char;
                 constructor init(R : TRect; default : char);
                 procedure draw; virtual;
                 procedure HandleEvent(var event : TEvent); virtual;
                 procedure GetData(var rec); virtual;
                 procedure SetData(var rec); virtual;
                 end;
  PWaardeView = ^TWaardeView;
  TWaardeView = object(TGroup)
                waarde : byte;
                lineinput : PInputLine;
                constructor init(R : TRect; default : char);
                procedure setdata(var rec); virtual;
                function askData : string;
                end;
  PAsciiTeken = ^TAsciiTeken;
  TAsciiTeken = object(TGroup)
                teken : char;
                scroller : PSCrollAscii;
                WaardeV : PWaardeView;
                constructor init(R : TRect; default : char);
                procedure HandleEvent(var event : TEvent); virtual;
                procedure getData(var rec); virtual;
                end;
  PSet = ^TSet;
  TSet = array[1..2048] of byte;
  PSetView =^TSetView;
  TSetView = object(TView)
             gegevens : TSet;
             SetVeranderd : boolean;
             XPos, YPos : word;
             Pad : Pathstr;
             Zoomstate : boolean;
             printdata : TPrintData;
             constructor init(bounds : TRect; IPad : Pathstr);
             procedure HandleEvent (var event : TEvent); virtual;
             procedure draw; virtual;
             function Valid(Command : word) : boolean; virtual;
             procedure SetIsVeranderd;
             procedure SetIsNietVeranderd;
             function Save : boolean;
             function SaveAs : boolean;
             procedure print;
             private
               function SaveHetuiteindelijk(Ipad : pathstr) : boolean;
             end;
  PSetWindow = ^TSetWindow;
  TSetWindow = object(TWindow)
               grootte : Tpoint;
               Houder : PSetView;
               LocaleMenuBar : PMenubar;
               indicator : PIndicator;
               scrollbar : PSCrollBar;
               constructor init(Bounds : TRect; IPad : pathstr);
               procedure HandleEvent(var event : TEvent); virtual;
               procedure SetState(AState: Word; Enable: Boolean); virtual;
               procedure SizeLimits(var min, max : TPoint); virtual;
               destructor done; virtual;
               end;


VAR

  FontViewNummer : byte;


                        IMPLEMENTATION


(***************************************************************)
(*                                                             *)
(*                 TScrollAscii                                *)
(*                                                             *)
(***************************************************************)
procedure TScrollAscii.SetData(var rec);

  begin

    move(rec,teken,1);
    DrawView;

  end;


constructor TScrollAscii.init(R : trect; default : char);

  begin

    TView.init(R);
    teken:=default;

  end;


procedure TScrollAscii.HandleEvent(var event : TEvent);

  label

    verlaat;

  begin

    TView.HandleEvent(event);
    case event.what of
      evKeyDown : begin
                  case event.keycode of
                    kbRight : teken:=chr(ord(teken)+1);
                    kbLeft  : teken:=chr(ord(teken)-1);
                    kbEnd   : teken:=#255;
                    kbHome  : teken:=#0;
                    else begin
                         case event.charcode of
                           #13, #0, #9 : goto verlaat
                           else teken:=event.charcode;
                           end;
                         end;
                    end;
                  drawview;
                  clearevent(event);
                  end;
      end;
    Message(owner,evBroadcast,cmZetWaarde,nil);
    verlaat:

  end;


procedure TScrollascii.draw;

  var

    Buffer  : TDrawBuffer;
    temp    : byte;
    C       : word;
    tellerX : byte;

  begin

    C:=getcolor(1);
    Movechar(Buffer,' ',C,size.X);
    temp:=ord(teken)-size.x div 2;
    for tellerX:=0 to size.x do
      begin
      Movechar(Buffer[tellerX],chr(temp),C,1);
      temp:=temp+1;
      end;
    Writeline(0,0,Size.X,1,buffer);
    Movechar(Buffer,' ',C, size.X);
    Movechar(Buffer[size.x div 2], #24, C, 1);
    Writeline(0,1,size.x,1,buffer);

  end;


procedure TScrollAscii.Getdata(var rec);

  begin

    move(teken,rec,1);

  end;


(***************************************************************)
(*                                                             *)
(*                 TWaardeView                                 *)
(*                                                             *)
(***************************************************************)
procedure TWaardeView.setdata(var rec);

  var

    temp : string;

  begin

    move(rec,waarde,1);
    str(waarde,temp);
    lineinput^.setdata(temp);

  end;


function TWaardeView.AskData : string;

  begin

    Askdata:=LineInput^.data^;

  end;


constructor TWaardeView.init(R : TRect; default : char);

  var

    Rechts : byte;

  begin

    TGroup.init(R);
    GetExtent(R);
    Rechts:=R.B.X;
    R.B.Y:=R.A.Y+1;
    R.B.X:=R.A.X+9;
    Tgroup.insert(new(PStatictext,init(R,'Waarde ? ')));
    R.A.X:=R.B.X;
    R.B.X:=R.A.X+5;
    LineInput:=new(PInputline,init(R,3));
    TGroup.insert(Lineinput);
    R.A.X:=R.B.X;
    R.B.X:=rechts;
    if rechts>R.A.X then TGroup.insert(new(PStaticText,init(R,'')));

  end;


(***************************************************************)
(*                                                             *)
(*                 TAsciiTeken                                 *)
(*                                                             *)
(***************************************************************)
constructor TAsciiTeken.init(R : TRect; default : char);

  begin

    TGroup.Init(R);
    teken:=default;
    R.A.Y:=0;
    R.A.X:=0;
    R.B.Y:=1;
    WaardeV:=new(PWaardeView,init(R,default));
    TGroup.insert(WaardeV);
    R.A.Y:=1;
    R.B.Y:=3;
    R.A.X:=0;
    Scroller:=new(PScrollAscii,init(R,default));
    TGroup.insert(Scroller);
    WaardeV^.setdata(default);
    Scroller^.setdata(default);

  end;


procedure TAsciiTeken.HandleEvent (var event : TEvent);

  var

    temp : byte;
    error : integer;
    str : string[3];

  procedure doWaardeView;

    begin

      WaardeV^.HandleEvent(event);
      str:=WaardeV^.askdata;
      val(str,temp,error);
      teken:=chr(temp);
      Scroller^.setData(teken);

    end;


  begin

    case event.what of
      evkeydown : begin
                  case event.keycode of
                    kbBack : DoWaardeView;
                    else begin
                         case event.charcode of
                           '0'..'9' : DoWaardeView;
                           else scroller^.HandleEvent(event);
                           end;
                         end;
                    end;
                  end;
      evBroadcast : begin
                    case event.Command of
                      cmZetWaarde :  begin
                                     scroller^.getdata(teken);
                                     WaardeV^.setdata(teken);
                                     clearevent(event);
                                     end;
                      end;
                    end;
      end;
    TGroup.HandleEvent(event);

  end;


procedure TAsciiTeken.GetData(var rec);

  begin

    move(teken,rec,1);

  end;


(***************************************************************)
(*                                                             *)
(*                 TSetView                                    *)
(*                                                             *)
(***************************************************************)
constructor TSetView.init(bounds : TRect; IPad : pathstr);

  var

    bestand : file of TSet;
    teller  : byte;
    R : TRect;

  begin

    TVIew.Init(bounds);
    helpctx:=hcFontWindow;
    if IPad='' then fillchar(gegevens,2048,#0) else
       begin
       if fileExists(Ipad) then
         begin
         assign(bestand,Ipad);
         reset(bestand);
         read(bestand,gegevens);
         close(bestand);
         end else fillchar(gegevens,2048,#0);
       end;
    Pad:=Ipad;
    setVeranderd:=false;
    Xpos:=1;
    Ypos:=1;
    Zoomstate:=false;
    GrowMode := gfGrowHiX + gfGrowHiY;
    Options := Options or ofFramed or ofTileAble;

  end;


procedure TSetView.SetIsNietVeranderd;

    begin

      message(owner, evBroadCast, cmNietVeranderd,@Pad);

    end;


procedure TsetView.SetIsVeranderd;

  begin

    if not(SetVeranderd) then
      begin
      setVeranderd:=true;
      Message(owner, evBroadCast, cmVeranderd, nil);
      end;

  end;


procedure TSetView.HandleEvent(var event : TEvent);

  var

    NewEvent : TEvent;

  procedure verplaatst;

    begin

      message(owner,evBroadcast,cmSetVerplaatst,@self);
      clearevent(event);

    end;


  procedure GoRight;

    begin

      if zoomstate then
          begin
          inc(Xpos);
          if ((Xpos-1) mod 8)=0 then Xpos:=Xpos-8;
          end
        else
          begin
          inc(Xpos);
          if Xpos>2048 then Xpos:=2048;
          end;
      verplaatst;
      drawview;

    end;


  procedure GoNextChar;

    begin

      Xpos:=XPos+8;
      if Xpos>2048 then Xpos:=2048;
      drawview;
      verplaatst;

    end;


  procedure GoPrevChar;

    begin

      Xpos:=XPos-8;
      if (Xpos<1) or (Xpos>2048) then Xpos:=1;
      drawview;
      verplaatst;

    end;


  procedure GoChar(welk : char);

    begin

      Xpos:=ord(welk)*8;
      inc(Xpos);
      DrawView;
      verplaatst;

    end;


  procedure GoDown;

    begin

      Ypos:=Ypos+1;
      if Ypos>8 then Ypos:=1;
      drawview;

    end;


  procedure GoUp;

    begin

      Ypos:=Ypos-1;
      if Ypos<1 then Ypos:=8;
      drawview;

    end;


  procedure GoLeft;

    begin

      if zoomstate then
          begin
          dec(Xpos);
          if ((Xpos+7) mod 8)=7 then Xpos:=Xpos+8;
          end
        else
          begin
          dec(Xpos);
          if Xpos<1 then Xpos:=1;
          end;
      drawview;
      verplaatst;

    end;


  procedure DoGoto;

    var

      Dialog : PDialog;
      temp   : char;
      R : TRect;

    begin

      R.Assign(0,0,50,12);
      New(Dialog,init(R,'Ga naar karakter'));
      R.Assign(8,2,42,3);
      Dialog^.insert(new(PStatictext,init(R,'Naar Welk teken moet ik springen ?')));
      R.Assign(8,4,42,7);
      Dialog^.insert(new(PAsciiTeken,init(R,chr((Xpos-1) div 8))));
      R.Assign(2,8,22,10);
      Dialog^.insert(new(PButton,init(R,'~O~K', cmOK, bfDefault)));
      R.Assign(27,8,47,10);
      Dialog^.insert(new(PButton,init(R,'~C~ancel', cmCancel, bfNormal)));
      dialog^.selectnext(false);
      dialog^.helpctx:=hcGoToDialog;
      if Desktop^.ExecView(dialog) = cmOK then
         begin
         dialog^.getdata(temp);
         GoChar(Temp);
         end;
      dispose(dialog,done);

    end;


  procedure DoZoom;

    begin

      Zoomstate:=not zoomstate;
      Drawview;

    end;


  procedure DoSwitch;

    begin

      Gegevens[XPos]:=gegevens[XPos] xor tweedemacht[YPos-1];
      DrawView;
      SetIsVeranderd;

    end;


  procedure DoClearChar;

    var

      temp : word;
      teller : word;

    begin

      temp := ((Xpos-1) div 8);
      temp := temp * 8 + 1;
      for teller:=temp to temp+7 do gegevens[teller]:=0;
      drawview;
      SetIsVeranderd;

    end;


  procedure DoInvers;

    var

      temp : word;
      teller : word;

    begin

      temp := ((Xpos-1) div 8);
      temp := temp * 8 + 1;
      for teller:=temp to temp+7 do gegevens[teller]:=gegevens[teller] xor 255;
      drawview;
      SetIsVeranderd;

    end;


  procedure DoFlipY(X : word);

    var

      teller : word;
      temp   : string[9];
      Y      : byte;

    begin

      for teller:=X to X+7 do
        begin
        temp:=splitbyte(gegevens[teller]);
        for Y:=1 to 4 do
           begin
           temp[9]:=temp[9-Y];
           temp[9-Y]:=temp[Y];
           temp[Y]:=temp[9];
           end;
        gegevens[teller]:=berekenbyte(temp);
        end;
      SetIsVeranderd;

    end;


  procedure DoFlipX(X : word);

    var

      temp : byte;
      teller : word;

    begin

      for teller:=0 to 3 do
        begin
        temp:=gegevens[X+7-Teller];
        gegevens[X+7-teller]:=gegevens[X+teller];
        gegevens[X+teller]:=temp;
        end;
      SetIsVeranderd;

    end;


  procedure DoGlobFlipX;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoFlipX(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


  procedure DoLeft(X : word);

    var

      temp : byte;
      teller : word;

    begin

      temp:=gegevens[X];
      for teller:=0 to 6 do gegevens[teller+X]:=gegevens[teller+1+X];
      gegevens[X+7]:=temp;
      SetIsVeranderd;

    end;


  procedure Doright(X : word);

    var

      temp : byte;
      teller : word;

    begin

      temp:=gegevens[X+7];
      for teller:=7 downto 1 do gegevens[teller+X]:=gegevens[teller-1+X];
      gegevens[X]:=temp;
      SetIsVeranderd;

    end;


 procedure DoGlobFlipY;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoFlipY(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


 procedure DoGlobL;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoLeft(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


 procedure DoDown(X : word);

   var

     teller : word;
     temp : byte;
     erbijtellen : byte;

   begin

     for teller:=X to X+7 do
       begin
       temp:=gegevens[teller];
       if odd(temp) then erbijtellen:=128 else erbijtellen:=0;
       temp:=(temp shr 1)+erbijtellen;;
       gegevens[teller]:=temp;
       end;
     SetIsVeranderd;

   end;


 procedure DoUp(X : word);

   var

     teller : word;
     temp : byte;
     erbijtellen : byte;

   begin

     for teller:=X to X+7 do
       begin
       temp:=gegevens[teller];
       if temp>127 then erbijtellen:=1 else erbijtellen:=0;
       temp:=(temp shl 1)+erbijtellen;;
       gegevens[teller]:=temp;
       end;
     SetIsVeranderd;

   end;


 procedure DoGlobR;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoRight(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


 procedure DoGlobU;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoUp(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


 procedure DoGlobD;

    var

      teller : word;

    begin

      for teller:=0 to 255 do DoDown(teller*8+1);
      DrawView;
      SetIsVeranderd;

    end;


  procedure DoCopy;

    var

      Dialog : Pdialog;
      R : TRect;
      teller : word;
      karakter : char;
      naar : char;

    begin

      R.Assign(0,0,50,13);
      New(Dialog,init(R,'copy char'));
      R.assign(9,2,41,3);
      karakter:=chr((Xpos-1) div 8);
      Dialog^.insert(new(PStaticText,init(R,'Kopiren van karakter '+
      karakter + ' naar ?')));
      R.assign(2,4,48,7);
      Dialog^.insert(new(PAsciiTeken,init(R,karakter)));
      R.Assign(2,9,22,11);
      Dialog^.insert(new(PButton,init(R,'~O~K', cmOk, bfDefault)));
      R.Assign(27,9,47,11);
      Dialog^.insert(new(PButton,init(R,'~C~ancel', cmCancel, bfNormal)));
      dialog^.selectnext(false);
      dialog^.helpctx:=hcCopyDialog;
      if Desktop^.execview(dialog) = cmOK then
         begin
         dialog^.getdata(naar);
         for teller:=0 to 7 do gegevens[ord(naar)*8+1+teller]:=gegevens[ord(karakter)*8+1+Teller];
         Drawview;
         SetIsVeranderd;
         end;
      dispose(dialog,done)

    end;


  procedure DoWissel;

    var

      Dialog : Pdialog;
      R : TRect;
      teller : word;
      karakter : char;
      naar : char;
      temp : byte;

    begin

      R.Assign(0,0,50,13);
      New(Dialog,init(R,'Wissel tekens'));
      R.assign(9,2,41,3);
      karakter:=chr((Xpos-1) div 8);
      Dialog^.insert(new(PStaticText,init(R,'Teken '+ karakter + ' wisselen met ?')));
      R.assign(2,4,48,7);
      Dialog^.insert(new(PAsciiTeken,init(R,karakter)));
      R.Assign(2,9,22,11);
      Dialog^.insert(new(PButton,init(R,'~O~K', cmOk, bfDefault)));
      R.Assign(27,9,47,11);
      Dialog^.insert(new(PButton,init(R,'~C~ancel', cmCancel, bfNormal)));
      dialog^.selectnext(false);
      Dialog^.helpctx:=hcwisseldialog;
      if Desktop^.execview(dialog) = cmOK then
         begin
         dialog^.getdata(naar);
         for teller:=0 to 7 do
           begin
           temp:=gegevens[ord(naar)*8+1+teller];
           gegevens[ord(naar)*8+1+teller]:=gegevens[ord(karakter)*8+1+Teller];
           gegevens[ord(karakter)*8+1+teller]:=temp;
           end;
         Drawview;
         SetIsVeranderd;
         end;
      dispose(dialog,done);

    end;


  procedure DoScrollBarChanged;

    begin

      Xpos:=PScrollBar(event.Infoptr)^.value;
      drawview;

    end;


  procedure GlobaalInvers;

    var

      teller : word;

    begin

      For teller:=1 to 2048 do gegevens[teller]:=not(gegevens[teller]);
      drawview;
      SetIsVeranderd;

    end;


  begin

    TView.HandleEvent(event);
    case event.what of
      evBroadcast : begin
                    case event.command of
                      cmScrollBarChanged : DoScrollBarChanged;
                      end;
                    end;
      evCommand : begin
                  case event.Command of
                    cmGlobI : GlobaalInvers;
                    cmNextChar : GoNextChar;
                    cmPrevChar : GoPrevChar;
                    cmZoomChar : doZoom;
                    cmGoTo     : DoGoTo;
                    cmLastChar : GoChar(#255);
                    cmFirstChar : GoChar(#0);
                    cmClear : DoClearchar;
                    cmGlobU : DoGlobU;
                    cmGlobD : DoGlobD;
                    cmInvers : DoInvers;
                    cmFlipX  : begin
                               DoFlipX(((Xpos-1) div 8) * 8 + 1);
                               drawview;
                               end;
                    cmFlipY : begin
                              DoFlipY(((XPos-1) div 8) * 8 +1);
                              drawview;
                              end;
                    cmGlobX  : DoGlobFlipX;
                    cmGlobY  : DoGlobFlipY;
                    cmLeft : begin
                             DoLeft(((Xpos-1) div 8) * 8 + 1);
                             drawview;
                             end;
                    cmRight : begin
                              DoRight(((Xpos-1) div 8) * 8 + 1);
                              drawview;
                              end;
                    cmUp : begin
                           DoUp(((Xpos-1) div 8) * 8 + 1);
                           drawview;
                           end;
                    cmDown : begin
                             DoDown(((Xpos - 1) div 8) * 8 +1);
                             drawview;
                             end;
                    cmGlobL : DoGlobL;
                    cmGlobR : DoGlobR;
                    cmCopy : DoCopy;
                    cmWissel : DoWissel;
                    cmSave : if Save then SetIsNietVeranderd else clearevent(event);
                    cmSaveAs : if SaveAs then SetIsNietVeranderd else clearevent(event);
                    cmPrint : Print;
                    end;
                  end;
      evKeyDown : begin
                  case event.keycode of
                    kbRight : GoRight;
                    kbLeft  : GoLeft;
                    kbCtrlPgdn : GoChar(#255);
                    kbCtrlPgUp : GoChar(#0);
                    kbDown  : GoDown;
                    kbup    : GoUp;
                    else begin
                         case upcase(event.charcode) of
                           'G' : DoGoto;
                           'Z' : DoZoom;
                           'C' : DoClearChar;
                           'I' : DoInvers;
                           'L' : begin
                                 DoLeft(((Xpos-1) div 8) * 8 + 1);
                                 drawview;
                                 end;
                           'R' : begin
                                 DoRight(((Xpos-1) div 8) * 8 + 1);
                                 drawview;
                                 end;
                           'X' : begin
                                 DoFlipX(((Xpos-1) div 8) * 8 + 1);
                                 DrawView;
                                 end;
                           'Y' : begin
                                 DoFlipY(((XPos-1) div 8) * 8 +1);
                                 drawview;
                                 end;
                           'U' : begin
                                 DoUp(((Xpos-1) div 8) * 8 + 1);
                                 drawview;
                                 end;
                           'D' : begin
                                 DoDown(((Xpos - 1) div 8) * 8 +1);
                                 drawview;
                                 end;
                           ' ' : doswitch;
                           end;
                         end;
                    end;
                  end;
      end;

  end;


function TSetView.SaveHetUiteindelijk(Ipad : pathstr) : boolean;

    var

      bestand : file of TSet;

    begin

      pad:=Ipad;
      system.Assign(bestand,pad);
      system.Rewrite(bestand);
      system.Write(bestand,gegevens);
      system.close(bestand);
      SetVeranderd:=false;
      savehetuiteindelijk:=true;

    end;


function TsetView.SaveAs : boolean;

    var

      filename : pathstr;

    begin

      saveas:=false;
      filename:='*.*';
      case ExecDialog(New(PFileDialog, Init('*.*', 'Save '+PWindow(owner)^.title^+' als',
      '~N~aam', fdSaveButton, 100)), @FileName) of
      cmCancel : exit;
      else
        begin
        if fileexists(filename) then
          begin
          if Messagebox('De file '+filename+' bestaat reeds, '+
          'toch overschrijven',nil,mfYesButton+mfNoButton+
          mfWarning)<>cmYes then exit;
          end;
        saveas:=SaveHetuiteindelijk(filename);
        end;
      end;
    end;


function TsetView.Save : boolean;

    begin

      save:=false;
      if SetVeranderd then
         begin
         if Pad=''
           then save:=saveas
           else save:=SaveHetuiteindelijk(pad);
         end;

    end;


procedure TSetView.Draw;

  var

    Y : byte;
    CN : word;
    Buffer : TDrawBuffer;
    XTeller, YTeller : byte;
    temp     : longint;
    CI       : word;
    aantalperX : byte;
    aantalperY : byte;
    laatste    : byte;
    localepositie : word;
    oorsprong     : word;

  begin

    CN:=GetColor(6);
    CI:=GetColor(7);
    if zoomstate then
        begin
        aantalperX:=size.x div 8;
        aantalperY:=(size.y-3) div 8;
        oorsprong:=(Xpos-1) div 8;
        oorsprong:=oorsprong * 8;
        laatste:=aantalperX*8;
        for YTeller:=0 to 7 do
          begin
          MoveChar(Buffer,' ',CN,size.X);
          Movechar(buffer[laatste],'',CN,1);
          For Xteller:=0 to 7 do
            begin
            localepositie:=XTeller+1+Oorsprong;
            if (localepositie=Xpos) and (Ypos-1=YTeller)
              then MoveChar(Buffer[XTeller*AantalperX], 'x', bitnummer(Yteller,gegevens[localepositie], CN, CI), aantalperX)
              else MoveChar(Buffer[XTeller*AantalperX], ' ', bitnummer(YTeller,Gegevens[Localepositie], CN, CI), aantalperX);
            end;
          Writeline(0,YTeller*AantalperY, size.X, aantalPerY, Buffer);
          end;
        Y:=8*aantalperY;
        MoveChar(Buffer,' ',CN,size.X);
        for YTeller:=Y to size.Y do
          begin
          Movechar(buffer,' ',CN,size.X);
          if YTeller=Y then
             begin
             Movechar(Buffer,'',CN,laatste);
             MoveChar(Buffer[laatste],'',CN,1);
             end;
          if YTeller=Y+1 then Movestr(Buffer,'Karakter : '+chr(oorsprong div 8), CN);
          if YTeller=Y+2 then MoveStr(Buffer,'Waarde : '+ Byte2str(oorsprong div 8), CN);
          Writeline(0,Yteller,size.X,1,Buffer);
          end;
        end
      else
        begin
        temp:=Xpos-size.X div 2;
        if temp<1 then temp:=1;
        if temp>(2049-size.X) then temp:=2049-size.X;
        localepositie:=word(temp);
        Y:=Size.Y;
        if Y>7 then Y:=7;
        for Yteller:=0 to Y do
          begin
          for Xteller:=0 to size.x do
            begin
            if ((Xteller+localepositie)=Xpos) and (YTeller+1=YPos)
              then MoveChar(Buffer[XTeller], 'x', bitnummer(Yteller,gegevens[localepositie+Xteller],CN,CI), 1)
              else MoveChar(Buffer[Xteller], ' ', bitNummer(YTeller,gegevens[localepositie+XTeller],CN,CI), 1);
            end;
          WriteLine(0, Yteller, size.x, 1, Buffer);
          end;
        MoveChar(Buffer,' ',CN,size.X);
        for YTeller:=Y+1 to Size.Y do if (Yteller<>Y+2) and (YTeller<>Y+3) then Writeline(0,YTeller,size.X,1,Buffer);
        if size.Y>Y+1 then
           begin
           for XTeller:=0 to Size.x do MoveChar(Buffer[XTeller],chr((XTeller-1+localepositie) div 8),CN,1);
           Writeline(0,Y+2,size.x,1,Buffer);
           end;
        if size.Y>Y+2 then
           begin
           MoveChar(buffer,' ',CN,size.X);
           for Xteller:=0 to size.X do
             begin
             if (((xteller-1) + localepositie) mod 8)=0 then
             MoveStr(Buffer[Xteller],byte2str((Xteller-1+localepositie) div 8), CN);
             end;
           Writeline(0,Y+3,size.x,1,buffer)
           end;
        end;

  end;


function TSetView.Valid(Command : word) : boolean;

  begin

    Valid:=true;
    case Command of
      cmClose, cmQuit : begin
                        if SetVeranderd then
                          begin
                          case MessageBox(Pwindow(owner)^.title^ + ' is veranderd. Save''n',nil,
                          mfWarning+mfYesButton+mfNoButton+mfCancelButton) of
                            cmYes : Save;
                            cmCancel : Valid:=false;
                            end;
                          end;
                        end;
      end;

  end;


procedure TSetView.Print;

  const

    naarbreedte : array[0..2] of word = (480, 960, 1920);

  var

    D : PDialog;
    R : TRect;
    CB : PCheckBoxes;
    IL : PInputline;
    aantalkeer : word;
    XTeller : byte;
    juistgeprint : boolean;
    positieinbuffer : word;
    PrintBuffer : TPrintbuffer;

  procedure printHetUiteindelijk(resolutie : byte);

    var

      grafischecode : string;
      aantal        : word;
      verstuurd : boolean;
      nummer    : word;
      waarwezijn : word;

    begin

      case resolutie of
        0 : grafischecode:=wagenterug+enkeledichtheid;
        1 : grafischecode:=wagenterug+dubbeledichtheid;
        2 : grafischecode:=wagenterug+viervoudigedichtheid;
        end;
      aantal:=naarbreedte[resolutie];
      grafischecode:=grafischecode+chr(lo(aantal))+chr(hi(aantal));
      {$I-}
      for nummer:=0 to 2 do
        begin
        repeat
          case nummer of
            0 : write(lst,grafischecode);
            1 : write(lst,movedown+#2+grafischecode);
            2 : writeln(lst);
            end;
          if IOResult<>0 then
             begin
             if SysErrorFunc(14,0)=1 then exit else verstuurd:=false;
             end else verstuurd:=true;
        until verstuurd;
        if nummer<>2 then
          begin
          for waarwezijn:=1 to aantal do
            begin
            repeat
              write(lst,chr(printbuffer[waarwezijn]));
              if IOResult<>0 then
                 begin
                 if SysErrorFunc(14,0)=1 then exit else verstuurd:=false;
                 end else verstuurd:=true;
            until verstuurd;
            end;
          end;
        end;
        juistgeprint:=true;
      {$I+}


    end;


  procedure ClearPrintBuffer;

    begin

      PositieInBuffer:=1;
      juistgeprint:=true;
      fillchar(Printbuffer,sizeof(printbuffer),0);

    end;


  procedure CopyTekenInBuffer(teken : byte; resolutie : byte);

    var

      som : word;
      temp : word;
      letter : byte;

    begin

      som:=teken*8;
      for temp:=1 to 8 do
        begin
        printbuffer[positieInBuffer]:=gegevens[temp+som];
        inc(positieinBuffer);
        end;
      juistgeprint:=false;
      if positieinbuffer>naarBreedte[resolutie]-10 then
         begin
         PrintHetuiteindelijk(resolutie);
         ClearPrintbuffer;
         end;

    end;


  begin

    R.assign(0,0,48,11);
    D:=new(PDialog,init(R,'Print font'));
    R.assign(3,3,24,5);
    CB:=new(PCheckBoxes,init(R,
      NewSItem('~T~ekst hiernaast',
      NewSitem('~V~olledig set',nil))));
    R.assign(26,3,46,4);
    IL:=new(PInputline,init(R,240));
    D^.insert(CB);
    D^.insert(IL);
    R.assign(25,2,32,3);
    D^.insert(new(PLabel,init(R,'~T~ekst',IL)));
    R.Assign(2,2,22,3);
    D^.insert(new(PLabel,init(R,'~W~at af te drukken',CB)));
    R.assign(2,7,22,9);
    D^.insert(new(PButton,init(R,'~P~rint',cmOK,bfDefault)));
    R.Assign(26,7,46,9);
    D^.insert(new(PButton,init(R,'~C~ancel',cmCancel,bfNormal)));
    D^.SetData(PrintData);
    D^.helpctx:=hcFontPrintDialog;
    if Desktop^.ExecView(D)=cmOK then
       begin
       D^.Getdata(PrintData);
       if (printdata.keuze and 3) = 0 then
       messagebox('Zo ga ik niet veel afprinten hoor !',nil,mfError + mfOKButton);
       if (printdata.keuze and 2) = 2 then
          begin
          for Aantalkeer:=0 to 2 do
            begin
            ClearPrintBuffer;
            For Xteller:=0 to 255 do CopyTekenInBuffer(Xteller, aantalkeer);
            if not juistgeprint then PrintHetuiteindelijk(Aantalkeer);
            end;
          end;
       if (printdata.keuze and  1) = 1 then
          begin
          for Aantalkeer:=0 to 2 do
            begin
            ClearPrintBuffer;
            For Xteller:=1 to length(printdata.tekst) do
            CopyTekenInBuffer(ord(printdata.tekst[Xteller]), aantalkeer);
            if not juistgeprint then PrintHetuiteindelijk(Aantalkeer);
            end;
          end;
       end;
    dispose(D,done);

  end;


(***************************************************************)
(*                                                             *)
(*                 TSetWindow                                  *)
(*                                                             *)
(***************************************************************)
constructor TSetWindow.init(Bounds : TRect; IPad : pathstr);

  var

    R : TRect;
    str : string;

  begin

    enablecommands(csWindowAfhankelijk);
    if IPad='' then
      begin
      inc(fontviewnummer);
      str:='Font '+byte2str(fontviewnummer);
      end else str:='Font '+Ipad;
    inc(windownummer);
    TWindow.init(Bounds, str, WindowNummer);
    getextent(R);
    R.A.X:=1;
    R.B.X:=4;
    R.A.Y:=R.B.Y-1;
    indicator:=new(PIndicator,init(R));
    Twindow.insert(indicator);
    R:=bounds;
    inc(R.A.X,6);
    dec(R.B.X,2);
    R.A.Y:=R.B.Y-1;
    scrollbar:=new(PScrollBar,init(R));
    scrollbar^.SetParams(1,1,2048,8,1);
    Twindow.insert(scrollbar);
    HelpCtx:=hcfontWindow;
    R:=Bounds;
    R.B.X:=R.B.X-R.A.X-1;
    R.B.Y:=R.B.Y-R.A.Y-1;
    R.A.Y:=3;
    R.A.X:=1;
    new(houder,init(R,Ipad));
    TWindow.insert(houder);
    options:=options or ofTileAble;
    R.A.Y:=1;
    R.B.Y:=2;
    Localemenubar:=new(PMenubar,init(R,newmenu(
      NewSubmenu('~G~lobaal', hcGlobaal,newmenu(
        NewItem('~L~eft', '', kbNoKey, cmGlobL, hcGlobLeft,
        NewItem('~R~ight','', kbnoKey, cmGlobR, hcGlobRight,
        NewItem('~U~p', '', kbNoKey, cmGlobU, hcGlobUp,
        NewItem('~D~own','', kbNoKey, cmGlobD, hcGlobDown,
        NewLine(
        NewItem('Flip ~x~','', kbNoKey, cmGlobX, hcGlobX,
        NewItem('Flip ~y~','', kbNoKey, cmGlobY, hcGlobY,
        NewLine(
        NewItem('~I~nvers','', kbNoKey, cmGlobI, hcGlobInverse,
        nil)))))))))),
      NewSubmenu('~K~arakter', hckarakter, newmenu(
        NewItem('~C~opy','Alt - C', kbAltC, cmCopy, hcCopy,
        NewItem('~W~issel','', kbNoKey, cmWissel, hcWissel,
        NewLine(
        NewItem('~L~edig', 'C', kbNoKey, cmClear, hcClear,
        NewItem('~I~nvers', 'I', kbNoKey, cmInvers, hcInverse,
        NewItem('Flip ~x~', 'X', kbNoKey, cmflipX, hcFlipX,
        NewItem('Flip ~y~', 'Y', kbNoKey, cmFlipY, hcFlipY,
        NewLine(
        NewItem('~L~eft','L', kbNoKey, cmLeft, hcLeft,
        NewItem('~R~ight','R', kbNoKey, cmRight, hcRight,
        NewItem('~U~p', 'U', kbNoKey, cmUp, hcUp,
        NewItem('~D~own', 'D', kbNoKey, cmDown, hcDown,
        NewLine(
        NewItem('~Z~oom/UnZoom', 'Z' , kbNoKey, cmZoomChar, hcFontZoom,
        nil))))))))))))))),
      NewSubMenu('~V~erplaats', hcVerplaats, newMenu(
        NewItem('~G~a naar','G', kbNoKey, cmGoTo, hcGoTo,
        NewItem('~N~ext','Ctrl - '#26, kbCtrlRight, cmNextChar, hcFontNext,
        NewItem('~P~revious','Ctrl - '#27, kbCtrlLeft, cmPrevChar, hcFontPrev,
        NewLine(
        NewItem('~L~ast','End', kbEnd, cmLastChar, hcFontEnd,
        NewItem('~F~irst','Home', kbHome, cmFirstChar, hcFontHome,
        nil))))))), nil))))));
    TWindow.insert(LocaleMenuBar);

  end;


procedure TSetWindow.SetState(AState: Word; Enable: Boolean);

  begin

    Twindow.SetState(AState,enable);
    if not(enable) and ((Astate and sfSelected) = sfSelected)
      then Indicator^.hide
      else
        begin
        Indicator^.show;
        enablecommands(csWindowafhankelijk);
        end;

  end;


destructor TSetWindow.Done;

  begin

    twindow.done;
    disablecommands(csWindowAfhankelijk);

  end;


procedure TSetWindow.HandleEvent(var event : TEvent);

  procedure DoSetNietVeranderd;

    var

      leespad : PString;
      tekst   : string;

    begin

      leespad:=event.Infoptr;
      disposestr(title);
      title:=NewStr('Font '+leespad^);
      indicator^.setvalue(false);
      frame^.drawview;

    end;


  begin

    TWindow.HandleEvent(event);
    case event.what of
      evbroadcast : begin
                    case event.Command of
                      cmVeranderd : begin
                                    indicator^.setvalue(true);
                                    clearevent(event);
                                    end;
                      cmNietVeranderd : begin
                                        DoSetNietVeranderd;
                                        clearevent(event);
                                        end;
                      cmSetVerplaatst : scrollbar^.Setvalue(PSetView(event.infoptr)^.XPos);
                      else houder^.HandleEvent(event);
                      end;
                    end;
      evKeyDown : begin
                  if event.keycode=kbAltF10 then
                    begin
                    event.what:=evcommand;
                    event.command:=cmMenu;
                    localemenubar^.handleevent(event);
                    clearevent(event);
                    end else houder^.handleevent(event);
                  end;
      else
        begin
        if event.what<>evnothing then houder^.HandleEvent(event);
        end;
      end;

  end;


procedure TSetWindow.SizeLimits(var min, max : Tpoint);

  begin

    TWindow.SizeLimits(min, max);
    min.X:=34;
    min.Y:=18;

  end;


END.
