UNIT GraphLst;


                                INTERFACE


USES

  Dos,
  Graph,
  lijnen,
  algemeen,
  printer2;


TYPE

  TData = array[1..4] of word;
  PLijn = ^Tlijn;
  PTekst =^TTekst;
  TTekst = record
           X : integer;                 {2 bytes}
           Y : integer;                 {2 bytes}
           TekstWijzer : PString;       {4 bytes}
           end;                         {totaal = 8 bytes}
  TLijn = record
          X1, Y1, X2, Y2 : integer;     {2 bytes * 4 = 8 bytes totaal}
          end;
  SoortTekening = (rechthoek, tekst, lines);
  PSingleGraph = ^TSingleGraph;
  TSingleGraph = object
                 Watishet : SoortTekening;
                 Volgende : pointer;
                 Data : TData;
                 procedure Teken(deltax,deltay : integer);
                 end;
  Printbuffertype = array[1..1920] of byte;
  PListgraph = ^TListgraph;
  TListGraph = object
               aantal : word;
               constructor init;
               procedure Line(X1,Y1,X2,Y2 : integer);
               procedure OutTextXY(IX, IY : integer; Tekstwijzer : pointer);
               procedure rectangle(X1,Y1,X2,Y2 : integer);
               procedure teken(deltax,deltay : integer);
               procedure Print(hoogteVanFiguur : word; BR, HR : word);
               private
                 start : PSinglegraph;
                 Laatste : PSingleGraph;
                 procedure voegtoe(wat : PSinglegraph);
                 procedure ClearPrintBuffer(var welke : PrintBufferType);
                 procedure BerekenPrintBuffer(Huidigrecord : pointer; Buffer : Pointer; Ypositie : word);
		 function  BufferLengte(Bufferstart : pointer) : word;
                 procedure MixBuffers(buffer1, buffer2, naar : pointer; soort : byte);
                 procedure VerdubbelBuffer(buffer : pointer; BufferDeel1 : pointer; BufferDeel2 : pointer);
                 procedure VerdubbelContents(buffer : pointer);
                 procedure SetBit(Buffer : pointer; Xpositie, Ypositie : word);
                 procedure PrintLijn(X1,Y1,X2,Y2,YPositie : word);
               end;


PROCEDURE LaadNieuweSet(fname : pathstr);

VAR

  TLedig : string;
  PLedig : PString;
  TTrue : string;
  PTrue : Pstring;
  TFalse : String;
  PFalse : Pstring;
  THerhaal : string;
  PHerhaal : PString;
  printbuffer1 : printbuffertype;
  printbuffer2 : printbuffertype;
  printbuffer3 : printbuffertype;
  Draft        : boolean;
  PositieInBuffer : word; {dit is een dummy voor gebruik in de machinetaalroutine}


                        IMPLEMENTATION


procedure KarakterSet; External;
{$L Karakter.obj}


procedure LaadNieuweSet;

  type

    PDraagover = ^TDraagover;
    TDraagOver = array[1..2048] of byte;

  var

    Kset : file;
    DraagOver : PDraagOver;

  begin

    Assign(KSet,Fname);
    Reset(KSet,2048);
    Draagover:=@Karakterset;
    BlockRead(KSet,Draagover^,1);
    Close(KSet);

  end;


{$F+}
procedure TListGraph.PrintLijn(X1,Y1,X2,Y2,YPositie : word); 

  begin

    X1:=X1;
    X2:=X2;
    Y1:=Y1;
    Y2:=Y2;

  end;
{$F-}


procedure TSingleGraph.teken(deltax, deltay : integer);

  var

    TekstPointer : PTekst;
    Lijnpointer  : PLijn;

  begin

    case watishet of
      rechthoek : begin
                  lijnpointer:=@data;
                  with lijnpointer^ do graph.rectangle(deltax+X1,deltay+Y1,deltax+X2,deltay+Y2);
                  end;
      lines  : begin
               LijnPointer:=@Data;
               with lijnpointer^ do Graph.Line(deltax+X1,deltay+Y1,deltax+X2,deltay+Y2);
               end;
      tekst  : begin
               Tekstpointer:=@Data;
               with tekstpointer^ do
                 begin
                 Graph.OutTextXY(deltaX+X,deltaY+Y,tekstwijzer^);
                 end;
               end;
      end;

  end;


constructor TListGraph.init;

  begin

    aantal:=0;
    laatste:=nil;

  end;


procedure TListGraph.OutTextXY(IX, IY : integer; TekstWijzer : pointer);

  var

    Single    : PSingleGraph;
    TekstData : TTekst;

  begin

    New(single);
    Single^.Watishet:=Tekst;
    TekstData.X:=IX;
    TekstData.Y:=IY;
    TekstData.TekstWijzer:=Tekstwijzer;
    Move(TekstData,single^.data,8);
    Voegtoe(Single);

  end;


procedure TListGraph.Line(X1, Y1, X2, Y2 : integer);

  var

    Single    : PSingleGraph;
    LijnData  : TLijn;

  begin

    New(single);
    Single^.Watishet:=Lines;
    if Y1<Y2 then
         begin
         LijnData.X1:=X1;
         LijnData.Y1:=Y1;
         LijnData.X2:=X2;
         LijnData.Y2:=Y2;
       end else
         begin
         Lijndata.X1:=X2;
         Lijndata.X2:=X1;
         Lijndata.Y1:=Y2;
         Lijndata.Y2:=Y1;
         end;
    Move(LijnData,single^.data,8);
    Voegtoe(single);

  end;


procedure TListGraph.Rectangle(X1, Y1, X2, Y2 : integer);

  var

    Single    : PSingleGraph;
    LijnData  : TLijn;

  begin

    New(single);
    Single^.Watishet:=rechthoek;
    LijnData.X1:=X1;
    LijnData.Y1:=Y1;
    LijnData.X2:=X2;
    LijnData.Y2:=Y2;
    Move(LijnData,single^.data,8);
    Voegtoe(single);

  end;


Procedure TListGraph.Voegtoe(wat : PSingleGraph);

  begin

    aantal:=aantal+1;
    wat^.volgende:=nil;
    if laatste=nil then
       begin
       start:=wat;
       laatste:=wat
       end else
       begin
       laatste^.volgende:=wat;
       laatste:=wat;
       end;


  end;

procedure TListGraph.Teken;

  var

    locale : PsingleGraph;

  begin

    locale:=start;
    if aantal>0 then
       begin
       while locale<>nil do
         begin
         locale^.teken(deltaX,deltay);
         locale:=locale^.volgende;
         end;
       end;

  end;


procedure TListGraph.ClearPrintBuffer(var welke : PrintBufferType);

  begin

    FillChar(welke,1920,#0);

  end;


procedure TListGraph.VerdubbelContents(buffer : pointer);  assembler;

  asm

      PUSH      DS              {voor pascal}
      MOV       CX,960          {de lus moet 959 maal doorlopen worden}
      MOV       DX,1920         {DX begint op positie 1919}
    @@Lus:
      DEC       CX
      DEC       DX
      DEC       DX
      LDS       SI,Buffer       {in DS:SI steekt de pointer naar buffer}
      MOV       BX,SI           {bijhouden voor later gebruik}
      ADD       SI,CX           {tel er DX bij op}
      MOV       AL,[DS:SI]
      MOV       AH,AL           {verdubbel de waarde}
      MOV       SI,BX           {haal de oorspronkelijke waarde weer}
      ADD       SI,DX           {breng de positie nu naar waar het moet komen}
      MOV       [DS:SI],AX      {steek er nu de dubbele waarde}
      CMP       CX,0            {is CX geen 0}
      JNE       @@Lus           {dan blijven we het herhalen}
      POP       DS              {nmaal is voldoende}

  end;


procedure TListGraph.VerdubbelBuffer(buffer : pointer; BufferDeel1 : pointer; BufferDeel2 : pointer); assembler;

  asm

    PUSH	DS		{bewaren voor pascal}
    MOV 	CX,1920		{de routine moet 1920 keer doorlopen worden}
    MOV         DX,1920         {er zijn 1920 adressen in de buffers}
    @@LoopBufferDoor:
    DEC         DX
    LDS		SI,Buffer	{in DS:SI steekt nu buffer}
    ADD		SI,DX
    MOV		AL,[DS:SI]	{in AL steekt de huidige waarde}
    CALL        @@Verdubbel     {verdubbel deze byte nu tot AH en AL}
    LDS		SI,BufferDeel1	{In DS:SI steekt nu buffer2}
    ADD		SI,DX
    MOV		[DS:SI],AH
    LDS		SI,BufferDeel2
    ADD		SI,DX
    MOV		[DS:SI],AL	{we schrijven De nieuwe waarde in deze buffer}
    LOOP	@@LoopBufferDoor
    JMP         @@Einde

    @@Verdubbel:
    PUSH       DX
    PUSH       BX
    PUSH       CX
    MOV        CX,8             {er moeten 8 bits gedraaid worden}
    @@VolgendeBit:
    MOV        BX,0             {steek in BX 0}
    CLC                         {maak de carry leeg om geen afval toe te voegen}
    RCL        AL,1             {draai AX 1 naar links}
    ADC        BX,0             {steek de carry in BX}
    PUSH       BX               {bewaar BX op de stapel}
    LOOP       @@VolgendeBit

    MOV        AX,0             {In AL komt 0, voor de zekerheid}
    MOV        CX,8             {nu moeten er 8 bits gelezen worden}
    @@PlaatsTerugInByte:
    POP        DX               {haal n byte terug}
    MOV        BX,DX            {BX zorgt dat de carry goed komt te staan}
    ADD        BX,65535         {indien BX 1 dan C=1 else C=0}
    RCR        AX,1             {we draaien de carry er dan in}
    MOV        BX,DX
    ADD        BX,65535
    RCR        AX,1
    LOOP       @@PlaatsTerugInByte
    POP        CX               {we keren terug}
    POP        BX
    POP        DX
    RETN

    @@Einde:
    POP  	DS		{pascal heeft deze nog steeds nodig}

  end;


procedure TListGraph.MixBuffers(buffer1, buffer2, naar : pointer; soort : byte); assembler;

  asm

    PUSH	DS		{bewaren voor pascal}
    MOV 	CX,1920		{de routine moet 1920 keer doorlopen worden}
    MOV         DX,1920         {er zijn 1920 adressen in de buffers}
    @@LoopBufferDoor:
    DEC         DX
    LDS		SI,Buffer1	{in DS:SI steekt nu buffer1}
    ADD		SI,DX
    MOV		AH,[DS:SI]	{in AL steekt de huidige waarde}
    LDS		SI,Buffer2	{In DS:SI steekt nu buffer2}
    ADD		SI,DX
    MOV		AL,[DS:SI]	{In AH steekt buffer 2}
    CALL	@@MepIneen      {Verander de bytes tot n byte die in AL komt}
    LDS		SI,naar		{in DS:SI steekt nu buffer3}
    ADD		SI,DX
    MOV		[DS:SI],AL	{we schrijven De nieuwe waarde in deze buffer}
    LOOP	@@LoopBufferDoor
    JMP         @@Einde

    @@MepIneen:
    PUSH       BX
    PUSH       CX
    MOV        BL,Soort         {Lees het soort af}
    CMP        BL,1             {is het geen 1 dan telt de eerste bit mee}
    JNE        @@DoeVerder
    CLC
    RCL        AX,1             {verwijder dan de eerste bit}
    @@DoeVerder:
    MOV        CX,8             {er moeten 8 bits gedraaid worden}
    @@VolgendeBit:
    MOV        BX,0             {steek in BX 0}
    CLC                         {maak de carry leeg om geen afval toe te voegen}
    RCL        AX,1             {draai AX 1 naar links}
    ADC        BX,0             {steek de carry in BX}
    PUSH       BX               {bewaar BX op de stapel}
    CLC                         {verwijder dan nu}
    RCL        AX,1             {de tweede bit}
    LOOP       @@VolgendeBit

    MOV        AL,0             {In AL komt 0, voor de zekerheid}
    MOV        CX,8             {nu moeten er 8 bits gelezen worden}
    @@PlaatsTerugInByte:
    POP        BX               {haal n byte terug}
    ADD        BX,65535         {indien BX 1 dan C=1 else C=0}
    RCR        AL,1             {we draaien de carry er dan in}
    LOOP       @@PlaatsTerugInByte
    POP        CX               {we keren terug}
    POP        BX
    RETN

    @@Einde:
    POP  	DS		{pascal heeft deze nog steeds nodig}

  end;


function TListGraph.BufferLengte(Bufferstart : pointer) : word;  assembler;

  asm
  
    PUSH 	DS		{DS bewaren voor pascal}
    LDS		CX,BufferStart	{Het begin van de buffer komt in DX en DS}
    MOV		SI,CX	
    ADD		SI,1920		{We nemen het einde van de buffer onmiddelijk}
    MOV         CX,1920
  @@Herhaal:
    DEC		SI		{we verlagen SI}
    DEC         CX
    CMP		CX,65535	{is hij iets te veel gezakt dan stoppen we en is het 0}
    JE          @@Einde
    MOV		BL,[DS:SI]	{we lezen er het teken}
    CMP		BL,0		{is het een nul}
    JE		@@Herhaal	{dan herhalen we}
  @@Einde:
    MOV         AX,CX
    INC         AX              {er moet eentje bijgeteld worden}
    POP 	DS		{we halen DS terug voor pascal}  
  
  end;
  
  
procedure TListGraph.SetBit(Buffer : pointer; Xpositie, Ypositie : word); assembler;

  asm

    PUSH        DS
    LDS         SI,Buffer           {Steek in SI de offset van de printbuffer}
    MOV         AX,Xpositie
    ADD         SI,AX               {tel er de Xpositie bij}
    MOV         AH,128              {we beginnen van boven uit}
    MOV         CX,Ypositie         {Het aantal keren dat naar rechts moet gedraaid worden}
    SHR         AH,CL               {wordt bepaalt door de Ypositie}
    MOV         BL,[DS:SI]          {we lezen wat er reeds staat}
    OR          BL,AH               {we voegen de bit toe}
    MOV         [DS:SI],BL          {en steken de nieuwe waarde weer weg}
    POP         DS

  end;


procedure TListGraph.BerekenPrintBuffer(Huidigrecord : pointer; Buffer : Pointer; Ypositie : word);

  var

    LijnTekenen : boolean;
    X1, X2, Y1, Y2 : word;
    X,Y            : word;
    lijn           : Lijnen.Tlijn;

  begin

    repeat
      Lijntekenen:=false;
      asm
      PUSH      DS                      {bewaar DS}
{De lijst met alle grafische figuren (lijnen, rechthoeken en tekst) moet
 doorlopen worden totdat het einde van de lijst bereikt is. Dan wordt er pas gestopt}
    @@DoorloopTekenLijst:               {Hier doorlopen we alle buffers}
      LDS       SI,Huidigrecord         {in DS steekt het segment van het huidige record en}
    @@LoopVerderDoor:                   {in SI steekt de offset van dat record}
      MOV       BX,DS                   {controleer of het een nilpointer is}
      CMP       BX,0                    {BX moet dan 0 zijn en SI ook}
      JNE       @@CheckInhoud           {indien niet controleer dan de inhoud}
      CMP       SI,0                    {indien ook deze 0 is hebben we met een NIL te maken}
      JE        @@einde                 {en wordt er geindigd}

{Hier wordt de inhoud van zo'n record bekeken en verwerkt. Eerst
 wordt gekeken wat het is, 0 rechthoek, 1 tekst, 2 lijnen.
 Nadien wordt de verdere controle doorgegeven aan de routine die die
 figuur moet tekenen. De registers betekenen hier het volgende.
 DS:SI = pointer naar het huidige record.
 AL    = wat het is}
    @@CheckInhoud:                      {hier wordt de inhoud en dergelijke gecontroleerd}
      PUSH      DS                      {het DS en het SI register mogen hier niet}
      PUSH      SI                      {gewijzigd worden, enkel op het einde}
      MOV       AL,[DS:SI]              {Lees het field 'Watishet' uit}
      CMP       AL,1                    {1 is tekst}
      JNE       @@GeenTekst             {spring indien het geen tekst is}

{______________________________________________}
{                                              }
{                  TEKST                       }
{______________________________________________}
{Als het tekst is wordt deze routine aangeroepen. Hier worden alle tekens
 afgezocht maar nog niet getekend in de buffer.}
    @@Tekst:                            {als het tekst is ...}
      MOV       BX,[DS:SI+7]            {Steek in BX de Ypositie v/h begin v/d tekst}
      MOV       CX,BX                   {steek in CX, BX maar + 7 (hoogte van tekst)}
      ADD       CX,7
      CALL      @@BinnenBereik          {controleer of dit record meeteld}
      CMP       AX,0                    {0 is niet meerekenen}
      JE        @@VolgendRecord         {en dus overgaan naar het volgende record}
      ADD       DX,8                    {eerst wordt bij DX 8 bijgeteld (hoogte van tekst)}
      SUB       DX,BX                   {maak het verschil, dus hoeveel maal draaien}
      SUB       DX,7                    {we doen er weer 8 af om juist te zijn...}
      MOV       BX,DX                   {in BL steekt hoeveel maal gedraaid moet worden}
      MOV       DX,[DS:SI+5]            {de XPositie v/d tekst}
      CALL      @@ZetPositieInBuffer    {moet in 'positieInBuffer' komen}
      LDS       SI,[DS:SI+9]            {lees de tekstwijzer}
      MOV       CL,[DS:SI]              {in CX het aantal tekens in de string}
      MOV       CH,0                    {De hoogste byte moet nul zijn omdat het anders een lange string wordt}
      CMP       CX,0                    {Als het nul is mag zelfs het eerste teken niet gelezen worden !!!}
      JE        @@VolgendRecord         {en moeten we doorgaan naar het volgende record}

{Vanaf hier is de pointer naar de tekst gekend en wordt elk teken gelezen}
      @@DoorloopTekst:                  {hier doorlopen we de string}
      INC       SI                      {SI moet stijgen}
      MOV       AL,[DS:SI]              {Ga het teken halen}

{Hier wordt het teken getekend in de printbuffer nadat de data's uit de karakterset
 gehaald zijn.}
      PUSH      DS                      {en we bewaren nogmaals alle registers}
      PUSH      SI                      {omdat dit normaal een subroutine is}
      PUSH      AX                      {maar omwille van de snelheid maak ik}
      PUSH      BX                      {er geen subroutine van}
      PUSH      CX
      MOV	CL,3
      MOV       AH,0                    {Bereken de positie binnen karakterset}
      SHL       AX,CL                   {n teken bestaat uit 8 bytes}
      POP	CX
      PUSH 	CX
      PUSH      BX
      MOV       BX,SEG Karakterset      {we halen de pointer naar de karakterset}
      MOV       DS,BX                   {het segmengt ervan komt in DS}
      MOV       SI,OFFSET Karakterset   {en de offset in SI}
      ADD       SI,AX                   {de positie binnen de karakterset moet erbij geteld worden}
      POP       BX
      MOV       CX,8                    {Er moeten 8 bytes gezet worden}
      PUSH      AX
      MOV       AL,BL
      @@volgendeByte:
      PUSH      CX
      MOV       BL,[DS:SI]              {laad een byte uit het teken}
      MOV       BH,0                    {het hoogste gedeelte op 0 zetten}
      MOV       CL,AL                   {we zetten CL op hoeveel keer er gedraaid moet worden}
      SHL       BX,CL                   {We draaien het voldoende dat het op de juiste hoogte komt}
      PUSH      AX
      MOV       AL,BH                   {we steken de waarde in het juiste register...}
      CALL      @@BijInBuffer           {en sturen het op}
      POP       AX
      POP       CX
      INC       SI                      {de volgende byte uit het teken}
      LOOP      @@volgendeByte
      POP       AX
      POP       CX
      POP       BX
      POP       AX
      POP       SI
      POP       DS
      LOOP      @@DoorloopTekst         {herhaal todat einde string bereikt is}
      JMP       @@VolgendRecord         {Als we gedaan hebben moeten we overgaan naar het volgende record}

{______________________________________________}
{                                              }
{              RECHTHOEK                       }
{______________________________________________}
{indien het geen tekst was wordt hier voortgegaan met de andere routine.
 AX bevat hier de waarde die watishet bevat.}
    @@GeenTekst:
      CMP       AL,0                    {is het een rechthoek ???}
      JNE       @@GeenRechthoek         {indien niet dan springen we er over}

    @@Rechthoek:
      MOV       AX,[DS:SI+5]            {Lees X1}
      MOV       BX,[DS:SI+9]            {Lees X2}
      MOV       CX,[DS:SI+7]            {Lees Y1}
      CALL      @@HorizLijn             {Teken de bovenste lijn}
      MOV       CX,[DS:SI+11]           {Lees Y2}
      CALL      @@HorizLijn             {teken de onderste lijn}
      MOV       BX,[DS:SI+7]            {Lees Y1}
      MOV       CX,[DS:SI+11]           {Lees Y2}
      MOV       DX,[DS:SI+5]            {Lees X1}
      CALL      @@VertLijn              {teken de linkerlijn}
      MOV       DX,[DS:SI+9]            {Lees X2}
      CALL      @@VertLijn              {Teken de rechterlijn}
      JMP       @@VolgendRecord

{indien het geen rechthoek is wordt deze procedure aangeroepen en
 hebben we te maken met lijnen}
    @@GeenRechthoek:                    {als het geen rechthoek is dan is het een lijn}
      CMP       AL,2                    {maar toch controleer ik even...}
      JNE       @@VolgendRecord         {...voor de zekerheid}

{______________________________________________}
{                                              }
{              RECHTHOEK                       }
{______________________________________________}
    @@Lijn:
      MOV       AX,[DS:SI+5]            {Lees X1}
      MOV       DX,[DS:SI+9]            {Lees X2}
      CMP       AX,DX                   {Indien AX en BX gelijk zijn is het een vertikale}
      JNE       @@GeenVertikale
      MOV       BX,[DS:SI+7]            {Lees Y1}
      MOV       CX,[DS:SI+11]           {Lees Y2}
      CALL      @@VertLijn              {teken de lijn}
      JMP       @@VolgendRecord
      @@GeenVertikale:
      MOV       CX,[DS:SI+7]            {Lees Y1}
      MOV       BX,[DS:SI+11]           {Lees Y2}
      CMP       CX,BX                   {indien ze hetzelfde zijn is het een horizontale}
      JNE       @@GeenHorizontale
      MOV       AX,[DS:SI+5]            {Lees X1}
      MOV       BX,[DS:SI+9]            {Lees X2}
      CALL      @@HorizLijn             {teken de horizontale lijn}
      JMP       @@VolgendRecord
      @@GeenHorizontale:
      MOV       BX,[DS:SI+7]            {Lees Y1 en steek in BX}
      MOV       CX,[DS:SI+11]           {Lees Y2 en steek in CX}
      CALL      @@Binnenbereik          {controleer of het binnen dit bereik wel valt}
      CMP       AL,1                    {indien niet}
      JNE       @@VolgendRecord         {spring dan naar het volgende record}
      MOV       BYTE [LijnTekenen],1
      POP       SI                      {We lezen ook de positie van}
      POP       DS                      {het huidige record uit}
      MOV       AX,[DS:SI+1]
      MOV       WORD [Huidigrecord],AX
      MOV       AX,[DS:SI+3]
      MOV       WORD [Huidigrecord+2],AX
      MOV       AX,[DS:SI+5]
      MOV       [X1],AX
      MOV       AX,[DS:SI+9]
      MOV       [X2],AX
      MOV       AX,[DS:SI+7]
      MOV       [Y1],AX
      MOV       AX,[DS:SI+11]
      MOV       [Y2],AX
      JMP       @@Einde                 {en verlaten de subroutine even}


{Door naar hier te springen gaan we onmiddelijk door met het volgende record}
    @@volgendRecord:
      POP       SI                      {ze mochten dus niet gewijzigd worden}
      POP       DS                      {en dus halen we ze terug}
      LDS       SI,[DS:SI+1]            {we gaan de pointer verder lezen}
      JMP       @@LoopVerderDoor        {en we controleren dit record ook}

{______________________________________________}
{                                              }
{                SUBROUTINES                   }
{______________________________________________}
{Deze routine tekent een horizontale lijn in de buffer}
{AX : X1}
{BX : X2}
{CX : Y}
    @@HorizLijn:
      PUSH      SI              {we bewaren eerst alles zorgvuldig}
      PUSH      DS
      PUSH      BX
      PUSH      CX
      PUSH      DX
      PUSH      AX

      PUSH      BX
      MOV       BX,CX
      CALL      @@BinnenBereik  {Valt de lijn wel binnen het bereik}
      POP       BX

      CMP       AL,1            {is het geen n dan verlaten}
      JNE       @@EindeHorizLijn {we de functie}
      POP       AX              {We halen AX van de stapel zonder}
      PUSH      AX              {SP te veranderen}
      SUB       DX,CX           {We trekken er nu CX van af}
      MOV       CX,BX           {in CX steken we het eindpunt}
      INC       CX              {we verhogen met n om het beginpunt ook te tekenen}
      SUB       CX,AX           {hiervan trekken we er het beginpunt af}
      @@DoorloopLijn:           {In CX steekt de lengte}
      MOV       BX,CX           {in BX komt de relatieve positie}
      DEC       BX              {we trekken er n af}
      ADD       BX,AX           {bepaal nu de absolute positie}
      CALL      @@SetBitOpPositie  {Steek nu de bit waar hij hoort}
      LOOP      @@DoorloopLijn
      @@EindeHorizLijn:
      POP       AX
      POP       DX              {We halen alle registers terug}
      POP       CX
      POP       BX
      POP       DS
      POP       SI
      RETN

{Deze routine tekent een vertikale lijn in de buffer}
{DX : X}
{BX : Y1}
{CX : Y2}
    @@VertLijn:
      PUSH      SI              {we bewaren eerst alles zorgvuldig}
      PUSH      DS
      PUSH      BX
      PUSH      CX
      PUSH      AX
      PUSH      DX
      CALL      @@BinnenBereik  {Test of het binnen het opgegeven bereik valt}
      CMP       AL,1            {indien niet verlaat dan de functie}
      JNE       @@EindeVertLijn
      MOV       AX,DX           {zet AX op wat het stond IN de routine Binnenbereik}
      SUB       AX,7
      CMP       AX,BX           {indien AX>=BX dan is de beginbit 0}
      JB        @@BerekenBeginBit
      MOV       AL,0
      JMP       @@BeginBitIsBerekend
      @@BerekenBeginBit:
      SUB       BX,AX             {eerst trekken we AX af van BX}
      MOV       AL,BL             {dan plaatsen we in AL de beginpositie}
      @@BeginBitIsBerekend:
      CMP       CX,DX             {indien CX<DX dan}
      JB        @@BerekenEindBit  {bereken dan de eindbit}
      MOV       AH,7              {anders is hij 7}
      JMP       @@EindBitBerekend
      @@BerekenEindBit:
      SUB       DX,CX             {DX:=DX-CX}
      MOV       AH,7              {in AH steekt 7}
      SUB       AH,DL             {om er dan DL van af te trekken}
      @@EindBitBerekend:
      POP       DX                {We halen de Xpositie weer}
      PUSH      DX
      MOV       CX,8              {Er zijn 8 posities in een byte}
      MOV       BL,1              {we beginnen bij bit 0}
      MOV       BH,0              {BH wordt de OR-Byte}
      @@MaakMaskByte:
        DEC       CX                {we trekken er een af om met de juiste bit te werken}
        CMP       CL,AH             {indien CL>AH}
        JA        @@NietToeVoegen   {Dan hoort deze bit er niet bij}
        CMP       CL,AL             {Indien CL<AL}
        JB        @@NietToeVoegen   {dan hoort hij er ook niet bij}
        OR        BH,BL             {we voegen de bit toe}
        @@NietToeVoegen:
        INC       CX
        SHL       BL,1              {draai de mask bit n naar links om de volgende bit}
        LOOP      @@MaakMaskByte
      LDS       SI,Buffer         {We lezen de buffer uit}
      ADD       SI,DX             {tellen er de positie bij}
      MOV       AH,[DS:SI]        {lezen een byte}
      OR        AH,BH             {voegen de nodige bits toe}
      MOV       [DS:SI],AH        {schrijven de byte weer weg}
      @@EindeVertLijn:            {en het is afgelopen}
      POP       DX
      POP       AX                {als we alle registers weer goed zetten}
      POP       CX
      POP       BX
      POP       DS
      POP       SI
      RETN

{Deze routine zet een bepaalde bit aan in de buffer. De positie wordt bepaalt
door BX,DX (dx vanaf beneden tellen)}
   @@SetBitOpPositie:
     PUSH       SI
     PUSH       DS
     PUSH       BX
     PUSH       AX
     PUSH       CX
     LDS        SI,Buffer       {We laden de positie van de buffer}
     ADD        SI,BX           {We tellen er BX bij op}
     MOV        AL,1            {We beginnen van beneden}
     MOV        Cl,DL
     SHL        AL,CL           {we draaien AL op de juiste positie}
     MOV        BL,[DS:SI]      {we lezen er een waarde}
     OR         BL,AL           {we voegen er de bit bij}
     MOV        [DS:SI],BL      {we bewaren de rotzooi weer}
     POP        CX
     POP        AX
     POP        BX
     POP        DS
     POP        SI
     RETN

{Deze subroutine test of een opgegeven positie binnen het bereik van de
regel valt. Als AX bij terugkeer 1 bevat is het in orde en valt het binnen
het bereik van de huidige regel. Als AX 0 is past deze niet in de
regel en moet zelfs niet verder onderzocht worden. Hetgene dat doorgegeven
wordt aan de subroutine is BX en CX. BX is de bovengrens en CX is de ondergrens
van de tekening.}
    @@BinnenBereik:                     {dus is een functie de test of het huidige record binnen}
      MOV       AX,Ypositie             {Lees de Positie op het scherm, die geprint moet worden}
      MOV       DX,AX                   {DX is AX maar}
      ADD       DX,7                    {plus 7}
      CMP       BX,DX                   {vergelijk BX en DX}
      JA        @@KanNiet               {indien BX>DX kan het al niet}
      CMP       AX,CX                   {vergelijk CX en AX}
      JA        @@KanNiet               {indien AX > CX gaat het ook niet}
      @@Klopt:                          {voor al de rest gaat het}
      MOV       AX,1                    {1 slaat op : klopt}
      JMP       @@EindeBinnenBereik     {verlaat dan zonder AX op 0 te zetten}
      @@KanNiet:
      MOV       AX,0                    {0 slaat op : kan niet}
      @@EindeBinnenBereik:              {dit wordt aangeroepen om de boel te verlaten}
      RETN                              {en we verlaten de functie}

{Deze routine zet DX in de variabele positieinbuffer}
    @@ZetPositieInBuffer:
      PUSH      DS                      {men beware alles zorgvuldik ende voorzichtik...}
      PUSH      SI
      PUSH      BX
      MOV       BX,Seg positieinbuffer  {Men neemt in DS de segment vanne der variabelen}
      MOV       DS,BX                   {men verplaatse ook BX naar DS}
      MOV       SI,offset positieinbuffer  {we nemen de offset in SI}
      MOV       [DS:SI],DX              {we plaatsen de nieuwe waarde}
      POP       BX                      {we halen alles terug eens weer...}
      POP       SI
      POP       DS
      RETN

{Deze routine zet in DX de variabele positieinbuffer}
    @@LeesPositieInBuffer:
      PUSH      DS                      {men beware alles zorgvuldik ende voorzichtik...}
      PUSH      SI
      PUSH      BX
      MOV       BX,Seg positieinbuffer  {Men neemt in DS de segment vanne der variabelen}
      MOV       DS,BX                   {men verplaatse ook BX naar DS}
      MOV       SI,offset positieinbuffer  {we nemen de offset in SI}
      MOV       DX,[DS:SI]              {we halen de waarde en we steken die in DX}
      POP       BX                      {en we halen alles terug eens weer...}
      POP       SI
      POP       DS
      RETN

{Deze routine zet in de buffer van de regel n byte bij. De positie wordt
 zelf verhoogt. De toe te voegen byte moet in AL zitten !}
    @@BijInBuffer:
      PUSH      DS
      PUSH      BX
      PUSH      CX
      PUSH      DX
      CALL      @@LeesPositieInBuffer   {We zoeken de oude positie op en dan moet}
      LDS       BX,Buffer               {we lezen de pointer in in DS:BX}
      ADD       BX,DX                   {De bufferpositie wordt hierbij geteld}
      MOV       CL,[DS:BX]              {Dan wordt in CX de inhoud van de buffer (op die positie) gelezen}
      OR        CL,AL                   {men voegt enkel bits toe door OR}
      MOV       [DS:BX],CL              {deze veranderde waarde wordt weer weggeschreven}
      INC       DX                      {De positie in de buffer neemt toe}
      Call      @@ZetPositieInBuffer    {en wordt weer weggeschreven}
      POP       DX                      {alle registers worden weer normaal gezet}
      POP       CX
      POP       BX
      POP       DS
      RETN

{Deze wordt aangeroepen als er aan de routine direct een einde moet komen.}
    @@Einde:                            {hier komt het einde aan}
      Pop       DS                      {en we halen DS terug}

      end;  {van ASM}
      if LijnTekenen then
         begin
         Lijn.assign(X1,Y1,X2,Y2);
         if lijn.VoorkeurVoorYopX
            then
              begin
              Lijn.XGerangschikt;
              X:=lijn.X1-1;
              repeat
                X:=X+1;
                Y:=lijn.YopX(X);
              until (Y>=Ypositie) and (Y<=Ypositie+7);
              repeat
                SetBit(buffer,X,Y-Ypositie);
                X:=X+1;
                Y:=lijn.YopX(X);
              until (Y>(Ypositie+7)) or (Y<lijn.Bovenkant) or
              (Y>lijn.onderkant) or (Y<Ypositie) or (X>lijn.rechterkant);
              end
            else
              begin
              Lijn.Ygerangschikt;
              Y:=lijn.Y1-1;
              repeat
                Y:=Y+1;
                X:=lijn.XopY(Y);
              until (Y>=Ypositie) and (Y<=Ypositie+7);
              repeat
                SetBit(buffer,X,Y-Ypositie);
                Y:=Y+1;
                X:=lijn.XopY(Y);
              until (Y>(Ypositie+7)) or (Y<Lijn.Y1) or (Y>lijn.Y2) or (Y<Ypositie);
              end;
         end;
    until not(lijntekenen);

  end;  {van BEGIN}


procedure TListGraph.Print(hoogteVanFiguur : word; BR, HR : word);

  var

    teller       : word;
    regelnummer  : word;
    lengte	 : word;
    aantalregels : word;
    GrafischeCode : string[8];

  begin

    case BR of
      1 : if draft
             then GrafischeCode:=Enkeledichtheid
             else grafischecode:=dubbeledichtheid;
      2 : GrafischeCode:=Dubbeledichtheid;
      3 : Grafischecode:=ViervoudigeDichtheid;
      else
        begin
        CloseGraph;
        Writeln('Hier klopt iets niet...');
        halt;
        end;
      end;
    case HR of
      1,2 : aantalregels:=hoogtevanfiguur div 8 +1;
      3   : aantalregels:=hoogtevanfiguur div 16 +1;
      else
        begin
        closegraph;
        writeln('Hier klopt iets niet...');
        halt;
        end;
      end;
    for regelnummer:=0 to Aantalregels do
      begin
      ClearPrintBuffer(PrintBuffer1);
      ClearPrintBuffer(PrintBuffer2);
      ClearPrintBuffer(PrintBuffer3);
      case HR of
        1 : begin
            BerekenPrintBuffer(start,@Printbuffer1, regelnummer*8);
            if (BR=1) and (not draft) then VerdubbelContents(@PrintBuffer1);
            VerDubbelBuffer(@PrintBuffer1, @Printbuffer2, @Printbuffer3);
            lengte:=Bufferlengte(@Printbuffer1);
            WritePrinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
            BlockWrite(PrintBestand,printbuffer2,lengte);
            if not draft then
               begin
               writePrinter(movedown+#2);
               WritePrinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
               BlockWrite(PrintBestand,printbuffer2,lengte);
               writePrinter(movedown+#22);
               end else writeprinter(movedown+#24);
            Writeprinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
            BlockWrite(printbestand,Printbuffer3,lengte);
            if not draft then
               begin
               writeprinter(movedown+#2);
               Writeprinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
               BlockWrite(printbestand,Printbuffer3,lengte);
               writeprinter(movedown+#22);
               end else writeprinter(movedown+#24);
            end;
        2 : begin
            BerekenPrintBuffer(start, @printbuffer1, regelnummer*8);
            lengte:=bufferLengte(@Printbuffer1);
            WritePrinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
            BlockWrite(PrintBestand,printbuffer1,lengte);
            if not draft then
               begin
               WritePrinter(MoveDown+#2);
               WritePrinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
               Blockwrite(PrintBestand,printbuffer1,lengte);
               writePrinter(MoveDown+#22);
               end else writeprinter(movedown+#24);
            end;
        3 : begin
            BerekenPrintBuffer(start,@Printbuffer1, regelnummer*16);
            BerekenPrintBuffer(start,@Printbuffer2, regelnummer*16+8);
            MixBuffers(@PrintBuffer1, @Printbuffer2, @Printbuffer3, 0);
            lengte:=Bufferlengte(@Printbuffer3);
            Writeprinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
            Blockwrite(PrintBestand,printbuffer3,lengte);
            if not draft then
               begin
               writeprinter(movedown+#2);
               MixBuffers(@PrintBuffer1,@Printbuffer2, @Printbuffer3 , 1);
               lengte:=Bufferlengte(@Printbuffer3);
               Writeprinter(wagenterug+GrafischeCode+chr(lo(lengte))+chr(hi(lengte)));
               BlockWrite(printbestand,printbuffer3,lengte);
               writeprinter(movedown+#22);
               end else writeprinter(movedown+#24);
            end;
        end;
      end;

  end;


BEGIN

  TTrue:='WAAR';
  TFalse:=' VALS';
  THerhaal:='HERHAAL';
  TLedig:='';
  PTRue:=@TTrue;
  PFalse:=@TFalse;
  PHerhaal:=@THerhaal;
  PLedig:=@TLedig;
  Draft:=false;

END.
