PROGRAM P2NInst;
{$A+,B-,D-,E+,F+,G-,I+,L+,N-,O-,R-,S+,V+,X+}
{$M 16384,0,655360}

USES

  Crt,
  App,
  Dos,
  Font,
  Taal,
  Menus,
  Views,
  Memory,
  Param2,
  StdDlg2,
  Drivers,
  Dialogs,
  Objects,
  P2nHelp,
  MsgBox2,
  Helpfil2,
  Codering,
  Filelist,
  P2Ninst2;


TYPE

  PMyStatusLine = ^TMyStatusLine;
  TMyStatusLine = object(TStatusLine)
                  CONSTRUCTOR Init(var Bounds: TRect; ADefs: PStatusDef);
                  FUNCTION hint(AHelpctx : word) : string; virtual;
                  end;
  PSetmaker = ^TSetmaker;
  TSetmaker = object(Tapplication)
              CONSTRUCTOR init;
              PROCEDURE DoNewFont(IPad : Pathstr);
              PROCEDURE DoNewTaalWindow(Ipad : pathstr);
              PROCEDURE LaadFont;
              PROCEDURE LaadTaalWindow;
              PROCEDURE DoAbout;
              PROCEDURE LaadOnbekEND;
              PROCEDURE DoOpen(pad : pathstr);
              PROCEDURE DoTile;
              PROCEDURE DoCascade;
              PROCEDURE DoSaveAll;
              PROCEDURE DoDosshell;
              PROCEDURE DoChangeDir;
              PROCEDURE GetEvent(var Event: TEvent); virtual;
              PROCEDURE HandleEvent(var Event: TEvent); virtual;
              PROCEDURE InitMenuBar; virtual;
              PROCEDURE InitStatusLine; virtual;
              FUNCTION  getpalette : PPalette; virtual;
              END;


VAR

  Setmaker : TSetmaker;


function CalcHelpName: PathStr;

  var

    EXEName: PathStr;
    Dir: DirStr;
    Name: NameStr;
    Ext: ExtStr;

  begin

    if Lo(DosVersion) >= 3 then EXEName := ParamStr(0)
    else EXEName := FSearch('P2Ninst.EXE', GetEnv('PATH'));
    FSplit(EXEName, Dir, Name, Ext);
    if Dir[Length(Dir)] = '\' then Dec(Dir[0]);
    CalcHelpName := FSearch('P2NHelp.HLP', Dir);

  end;


constructor TMyStatusLine.Init(var Bounds: TRect; ADefs: PStatusDef);

  begin

    TStatusline.init(bounds,Adefs);

  end;


function TMyStatusLine.Hint(AHelpctx : word) : string;

  const

    DitIsDeHint : array[hcBeginMenus..hcEindeMenus] of string[58] =
    ('Desktop commando''s',                                         {Desktop}
     'Plechtige mededeling in welk programma je zit',                 {About}
     'Maakt het scherm leeg',                                  {Clear Screen}
     'Hertekent het scherm',                                {Refresh display}
     'Verlaat het programma',                                          {Exit}
     'Bevat de commando''s voor bestandsbeheer',                      {Files}
     'Maakt een nieuwe font of een nieuw vertaalbestand aan',           {New}
     'Maakt een nieuw vertaalbestand aan',               {New vertaalbestand}
     'Maakt een nieuwe font aan',                                  {new font}
     'Doet een file open',                                             {Open}
     'Laad een file als vertaalbestand of font',                    {Load as}
     'Bewaart het huidige window met de huidige naam',                 {Save}
     'Bewaart het huidige window met een opgegeven naam',           {Save as}
     'Bewaart alle open files',                                    {Save all}
     'Print het huidige window naar LPT1',                            {Print}
     'Verandert de huidige directory',                           {Change Dir}
     'Maakt een uitstapje naar dos',                               {Dosshell}
     'Laad een file als vertaalbestand',                       {Load as taal}
     'Laad een file als font',                                 {Load as font}
     'Management van alle geopende windows',                        {Windows}
     'Vergroot/verkleint of verplaatst huidige window',              {Resize}
     'Zoomt het huidige window',                                       {zoom}
     'Sluit het huidige window',                                      {Close}
     'Selecteerd het volgende window',                                 {Next}
     'Selecteerd het vorige window',                                   {Prev}
     'Rangschikt de windows zodat enkel de kaders zichtbaar zijn',  {Cascade}
     'Rangschikt de windows zodat ze allemaal zichtbaar zijn',         {Tile}
     'Zet de volledige set in inverse',                         {Globinverse}
     'Draait alle tekens n naar links',                          {GlobLeft}
     'Draait alle tekens n naar rechts',                        {GlobRight}
     'Draait alle tekens n naar boven',                            {GlobUp}
     'Draait alle tekens n naar beneden',                        {GlobDown}
     'bevat de commando''s die op de hele set werken',              {Globaal}
     'Draait het huidige teken n naar rechts',                     {rechts}
     'Spiegelt alle tekens in de Y-as',                              {Glob X}
     'Spiegelt alle tekens in de X-as',                              {Glob Y}
     'Maakt het huidige teken leeg',                                  {Clear}
     'Herteken het huidige teken in inverse',                       {inverse}
     'Draait het huidige teken n naar links',                        {left}
     'Draait het huidige teken n omhoog',                              {up}
     'Draait het huidige teken n omlaag',                            {down}
     'Spiegelt het huidige teken in de Y-as',                        {flip X}
     'Spiegelt het huidige teken in de X-as',                        {flip Y}
     'Copieert het huidige teken naar een ander teken',                {copy}
     'Wisselt twee karakters van plaats',                            {wissel}
     'Brengt de cursor naar een bepaalt teken',                        {goto}
     'Bevat commando''s voor het verplaatsen van de cursor',      {verplaats}
     'Brengt de cursor naar het eerste teken',                     {fonthome}
     'Brengt de cursor naar het laatste teken',                     {fontend}
     'Brengt de cursor naar het volgende teken',                   {fontnext}
     'Brengt de cursor naar het vorige teken',                     {fontprev}
     'Bevat commando''s enkel van toepassing op dit teken',        {karakter}
     'Zoomt of Unzoomt het teken waarmee je bezig bent');              {zoom}

  begin

    if (AHelpCtx>=hcBeginmenus) and (Ahelpctx<=hcEindemenus) then
    hint:=DitIsDeHint[AHelpCtx] else
    hint:='';

  end;


procedure TSetmaker.GetEvent(var Event: TEvent);

  var

    W: PWindow;
    HFile: PHelpFile;
    HelpStrm: PDosStream;
    cont : word;

  const

    HelpInUse: Boolean = False;

  begin

    TApplication.GetEvent(Event);
    case Event.What of
      evCommand:
        begin
        if (Event.Command = cmHelp) and not HelpInUse then
          begin
          HelpInUse := True;
          HelpStrm := New(PDosStream, Init(CalcHelpName, stOpenRead));
          HFile := New(PHelpFile, Init(HelpStrm));
          if HelpStrm^.Status <> stOk then
             begin
             MessageBox('Ik kan de help file niet openen. J !!!', nil, mfError + mfOkButton);
             Dispose(HFile, Done);
             end
             else
             begin
             W := New(PHelpWindow,Init(HFile, getHelpCtx));
             if ValidView(W) <> nil then
               begin
               ExecView(W);
               Dispose(W, Done);
               end;
             end;
          ClearEvent(Event);
          HelpInUse := False;
          end;
        end;
      end;

  end;


function TSetmaker.GetPalette: PPalette;

  const

    CNewColor = CColor + CHelpColor;
    CNewBlackWhite = CBlackWhite + CHelpBlackWhite;
    CNewMonochrome = CMonochrome + CHelpMonochrome;
    P: array[apColor..apMonochrome] of string[Length(CNewColor)] = (CNewColor, CNewBlackWhite, CNewMonochrome);

  begin

    GetPalette := @P[AppPalette];

  end;


PROCEDURE TSetmaker.LaadFont;

  var

    filename : pathstr;

  BEGIN


    FileName := '*.*';
    IF ExecDialog(New(PFileDialog, Init('*.*', 'Open font',
    '~N~aam', fdOpenButton, 100)), @FileName) <> cmCancel THEN
    DoNewFont(FileName);

  END;


PROCEDURE TSetmaker.LaadTaalWindow;

  var

    filename : pathstr;

  BEGIN


    FileName := '*.*';
    IF ExecDialog(New(PFileDialog, Init('*.*', 'Open vertaalbestand',
    '~N~aam', fdOpenButton, 100)), @FileName) <> cmCancel THEN
    DoNewTaalWindow(FileName);

  END;


PROCEDURE TSetmaker.LaadOnbekend;

  var

    filename : pathstr;

  BEGIN


    FileName := '*.*';
    IF ExecDialog(New(PFileDialog, Init('*.*', 'Open font of vertaalbestand',
    '~N~aam', fdOpenButton, 100)), @FileName) <> cmCancel THEN
    DoOpen(FileName);

  END;


constructor TSetMaker.init;

  var

    recursie : boolean;
    teller   : byte;
    filename : pathstr;
    bestanden : TFileList;

  BEGIN

    TApplication.Init;
    disablecommands(csWindowAfhankelijk);
    RegisterHelpFile;
    windownummer:=0;
    fontviewnummer:=0;
    taalnummer:=0;
    disableCommands([cmPrint, cmSave, cmSaveAs, cmSaveAll, cmTile, cmCascade]);
    recursie:=Parameters.zoekswitch('/R');
    for teller:=1 to parameters.aantal do
      BEGIN
      filename:=parameters.haal(teller);
      bestanden.reset(filename,recursie);
      while not bestanden.laatstefile do
        BEGIN
        doOpen(bestanden.pad);
        bestanden.nextfile;
        END;
      END;

  END;

PROCEDURE TSetMaker.DoNewFont(IPad : pathstr);

  var

    R : TRect;

  BEGIN

    IF desktop^.current=nil
      THEN Desktop^.Getextent(R)
      ELSE
        BEGIN
        Desktop^.current^.getextent(R);
        IF (R.B.X>34) AND (R.B.Y>18) THEN
           BEGIN
           R.Move(desktop^.current^.origin.X, desktop^.current^.origin.Y);
           inc(R.A.X);
           inc(R.A.Y);
           END ELSE Desktop^.GetExtent(R);
        END;
    Desktop^.insert(new(PSetWindow,init(R,IPad)));

  END;


PROCEDURE TSetMaker.DoNewTaalWindow(IPad : pathstr);

  var

    R : TRect;

  BEGIN

   IF desktop^.current=nil
     THEN Desktop^.Getextent(R)
     ELSE
       BEGIN
       Desktop^.current^.getextent(R);
       IF (R.B.X>34) AND (R.B.Y>18) THEN
          BEGIN
          R.Move(desktop^.current^.origin.X, desktop^.current^.origin.Y);
          inc(R.A.X);
          inc(R.A.Y);
          END ELSE Desktop^.GetExtent(R);
       END;
    Desktop^.insert(new(PTaalWindow,init(R,IPad)));

  END;


PROCEDURE TSetMaker.DoOpen(pad : pathstr);

  var

    bestand : file of byte;
    grootte : longint;

  BEGIN

    IF FileExists(pad) THEN
      BEGIN
      assign(bestand,pad);
      reset(bestand);
      grootte:=filesize(bestand);
      close(bestand);
      IF grootte=2048
         THEN DoNewFont(pad)
         ELSE DoNewTaalWindow(pad);
      END;

  END;


PROCEDURE TSetmaker.DoAbout;

  var

    R : TRECT;
    Dialog : PDialog;

  BEGIN

    R.assign(1,1,37,10);
    new(dialog,init(R,'About'));
    R.Assign(2,2,34,3);
    dialog^.insert(new(PStatictext,init(R,'Pas2ns vertaalbestand & Setmaker')));
    R.Assign(7,4,28,5);
    (*Door Werner Van Belle*)
    dialog^.insert(new(PStatictext,init(R,Code(#241#95#95#135#200#150 +
    #115#135#29#115#135#200#112#230#29#200#13#115#119#119#115))));
    R.Assign(13,6,23,8);
    dialog^.insert(new(PButton,init(R,'~O~K',cmOK, bfDefault)));
    dialog^.helpctx:=hcAboutDialog;
    Desktop^.execview(dialog);

  END;


PROCEDURE TSetmaker.DoTile;

  var

    R : TRect;

  BEGIN

    Desktop^.getextent(R);
    Desktop^.Tile(R);

  END;


PROCEDURE TSetmaker.DoSaveAll;

  PROCEDURE doSave(Viewken : PView); far;

    var

      stuurEvent : tEvent;

    BEGIN

      stuurEvent.what:=evCommand;
      stuurEvent.Command:=cmSave;
      Viewken^.HandleEvent(stuurEvent);

    END;

  BEGIN

    Desktop^.foreach(@DoSave);

  END;


PROCEDURE TSetmaker.DoCascade;

  var

    R : TRect;

  BEGIN

    Desktop^.getextent(R);
    Desktop^.cascade(R);

  END;


procedure TSetMaker.DoChangeDir;

  var

    D: PChDirDialog;

  begin

    D := New(PChDirDialog, Init(cdNormal, 101));
    if ValidView(D) <> nil then
      begin
      DeskTop^.ExecView(D);
      Dispose(D, Done);
      end;

  end;

procedure TSetMaker.DoDosShell;

  begin

    DoneSysError;
    DoneEvents;
    DoneVideo;
    DoneMemory;
    SetMemTop(HeapPtr);
    PrintStr('Typ EXIT om weer te keren ...');
    SwapVectors;
    Exec(GetEnv('COMSPEC'), '');
    SwapVectors;
    SetMemTop(HeapEnd);
    InitMemory;
    InitVideo;
    InitEvents;
    InitSysError;
    Redraw;

  end;


PROCEDURE TSetMaker.HandleEvent(var Event: TEvent);

  BEGIN

    TApplication.HandleEvent(Event);
    IF Event.What=evCommand THEN
      BEGIN
      CASE Event.Command OF
        cmAbout          : DoAbout;
        cmOpen           : LaadOnbekend;
        cmOpenFont       : LaadFont;
        cmOpenTaalWindow : LaadTaalWindow;
        cmNewFont        : DoNewFont('');
        cmNewTaalWindow  : DoNewTaalWindow('');
        cmTile           : DoTile;
        cmCascade        : Docascade;
        cmSaveAll        : DoSaveAll;
        cmDosshell       : DoDosshell;
        cmChDir          : DoChangeDir;
        cmClearScreen    : ClrScr;
        cmRedrawscreen   : redraw;
        END;
      ClearEvent(Event);
      END;

  END;


PROCEDURE TSetMaker.InitMenuBar;

  var

    R : TRect;

  BEGIN

    GetExtent(R);
    R.B.Y:=R.A.Y+1;
    Menubar:=New(PMenuBar,init(R,NewMenu(
      NewSubmenu('~D~esktop', hcDesktop, newmenu(
         NewItem('~A~bout', '', kbNoKey, cmAbout, hcAbout,
         NewItem('~C~lear Screen', '', kbNoKey, cmClearScreen, hcClearScreen,
         NewItem('~R~efresh display', '', kbNoKey, cmRedrawScreen, hcRefreshDisplay,
         NewItem('E~x~it', 'Alt - x', kbAltX, cmQuit, hcExit, nil))))),
      NewSubmenu('~F~ile', hcfiles, newmenu(
         NewSubMenu('~N~ew', hcNew, newmenu(
           NewItem('~F~ont', '', kbNoKey, cmNewFont, hcNewFont,
           NewItem('~V~ertaalbestand', '', kbNoKey, cmNewTaalWindow, hcNewVertaalBestand, nil))),
           NewItem('~O~pen ...', 'F3', kbF3, cmOpen, hcopen,
         NewSubmenu('~L~oad as', hcLoadAs, newmenu(
           NewItem('~F~ont ...', '', kbNoKey, cmOpenFont, hcLoadAsFont,
           NewItem('~V~ertaalbestand ...', '', kbNoKey, cmOpenTaalWindow, hcLoadAsVertaalBestand, nil))),
         NewItem('~S~ave', 'F2', kbF2, cmSave, hcSave,
         NewItem('S~a~ve as ...', '', kbNoKey, cmSaveAs, hcSaveAs,
         NewItem('Save a~l~l', '', kbNoKey, cmSaveAll, hcSaveAll,
         NewLine(
         NewItem('~P~rint','',kbNoKey,cmPrint,hcPrint,
         NewItem('~C~hange dir','',kbNoKey,cmChDir,hcChangeDir,
         NewItem('~D~osshell','', kbNoKey,cmDosshell,hcDosshell,nil))))))))))),
      NewSubmenu('~W~indows',hcWindows, newmenu(
         NewItem('~S~ize/move','Ctrl-F5',kbCtrlF5,cmResize,hcResize,
         NewItem('~Z~oom','F5',kbF5,cmZoom,hcZoom,
         NewItem('~N~ext','F6',kbF6,cmNext,hcNext,
         NewItem('~P~revious','Shift - F6',kbShiftF6, cmPrev, hcPrevious,
         NewItem('~T~ile','',kbNoKey,cmTile,hcTile,
         NewItem('C~a~scade','',kbNoKey,cmCascade,hcCascade,
         NewItem('~C~lose','Alt - F3',kbAltF3,cmClose,hcClose,nil)))))))),
         nil))))));

  END;



PROCEDURE TSetMaker.InitStatusLine;

  var

    R : TRect;

  function altijdaanwezig(status : byte; vervolg : PStatusItem) : pStatusItem;

    const

      woorden : array[1..7,false..true] of string[16] =
       (('','~F1~ Help'),
        ('','~Alt-X~ Exit'),
        ('','~F10~ Menu'),
        ('','~Alt-F3~ Close'),
        ('','~F5~ Zoom'),
        ('','~Ctrl-F5~ resize'),
        ('','~F6~ Next'));

    begin

      Altijdaanwezig:=
      NewStatusKey(woorden[1,(sdHelp and status)=sdHelp], kbF1, cmHelp,
      NewStatusKey(Woorden[2,(sdExit and status)=sdExit], kbAltX, cmQuit,
      NewStatusKey(Woorden[3,(sdMenu and status)=sdMenu], kbF10, cmMenu,
      NewStatusKey(Woorden[4,(sdClose and status)=sdClose], kbAltF3, cmClose,
      NewStatusKey(Woorden[5,(sdZoom and status)=sdZoom], kbF5, cmZoom,
      NewStatusKey(Woorden[6,(sdResize and status)=sdResize], kbCtrlF5, cmResize,
      NewStatusKey(Woorden[7,(sdNext and status)=sdNext], kbF6, cmNext,
      vervolg)))))));

    end;


  begin

    GetExtent(R);
    R.A.Y := R.B.Y - 1;
    Statusline:=New(PMyStatusLine, Init(R,
      NewStatusDef(hcNoContext, hcNoContext, Altijdaanwezig(sdHelp+sdMenu, nil),
      NewStatusDef(hcDragging, hcDragging, AltijdAanwezig(sdHelp,
        NewStatusKey('~'#24#25#27#26'~ Verplaats', kbNoKey, cmNoCommand,
        NewStatusKey('~Shift-'#24#25#27#26'~ grootte', kbNoKey, cmNoCommand,
        NewStatusKey('~~ OK', kbNoKey, cmNoCommand,
        NewStatusKey('~Esc~ Cancel', kbNoKey, cmNoCommand,nil))))),
      NewStatusDef(2,999,Altijdaanwezig(sdAll,nil),              
      NewstatusDef(hcBeginmenus, hcEindemenus, AltijdAanwezig(sdHelp,nil),       
      NewStatusDef(1101,9999,altijdaanwezig(sdAll,nil),
      NewStatusDef(hcGeblokeerd, hcGeblokeerd, altijdaanwezig(
        sdZoom+sdResize+sdClose,nil),nil))))))));

  end;


PROCEDURE GeefHelp;

  BEGIN

    HighVideo;
    (*Pas2ns setmaker & vertaalbestand (c) Copyright Werner Van Belle 1992*)
    Writeln(Code(#18#230#181#37#29#181#200#181#115#209#2#230 +
    #7#115#135#200#249#200#163#115#135#209#230#230#119#107 +
    #115#181#209#230#29#241#200#2#230#241#115#200#107#167 +
    #200#150#115#135#29#115#135#200#112#230#29#200#13#115 +
    #119#119#115#200#94#214#214#37));
    LowVideo;
    writeln('P2NINST filenames [/R]');
    writeln;
    writeln('   [/R] : doorzoek ook subdirectories');
    writeln;

  END;


BEGIN

  IF parameters.help
     THEN Geefhelp
     ELSE
       BEGIN
       Setmaker.init;
       Setmaker.Run;
       Setmaker.Done;
       END;

END.
