UNIT ReadFile;
{$X+,D-}

                        INTERFACE

USES Graph, Dos, StrList;

TYPE

  TBlok = object
          EOF : boolean;
          remstellenmee : boolean;
          FileSize : longint;
          bestand : file of char;
          positie : longint;
          LaatsteWoord : string;
          function  ReadChar : char;
          function  ReadWord : string;
          function  volgendWoord : string;
          PROCEDURE ReadTotPuntKomma(tekstToeTeVoegen : string; var StringList : PStringlist; IsPuntKomma : boolean);
          Function  TotEindeLijn : string;
          Procedure LeesTotThen(var StringList : PStringList);
          PROCEDURE LeesTotDO(var StringList : PStringlist; werkmetDO : boolean);
          PROCEDURE ReadTotNaImplementation;
          function  SpecVolgendWoord : string;
          function  VolgtPuntKomma : boolean;
          procedure Reset(IPad : pathstr);
          procedure ReadFNHoofding(var stringlist : PStringlist);
          procedure gotoend;
          procedure gotoDO;
          procedure done;
          procedure totnapuntkomma;
          procedure Onthoud;
          procedure remember;
          private
              OPositie : longint;
              OLW      : string;
              Orem     : boolean;
              OEOF     : boolean;
          end;

CONST

  WoordTekens = ['a'..'z', 'A'..'Z', '0'..'9', '_', '[', ']'];


FUNCTION Strip(str : string) : string;
FUNCTION StripBegin(str : string) : string;
FUNCTION StripEinde(str : string) : string;
FUNCTION UpcStr(str : string) : string;
FUNCTION StripLine(str : string) : string;
FUNCTION ReservedWord(str : string) : boolean;


                           IMPLEMENTATION


FUNCTION UpcStr(str : string) : string;

  var

    teller : byte;

  begin

    for teller:=1 to length(str) do str[teller]:=upcase(str[teller]);
    upcstr:=str;

  end;


procedure TBlok.ReadFNHoofding(var stringlist : PStringlist);

  var

    str : string;
    teken : char;

  function voegtoetot(controle : string; volledigwoord : boolean; var str : string) : boolean;

    var

      CReeks : array[1..4] of string;
      temp : string;
      AantalCs : integer;
      stop : boolean;
      teller : byte;

    begin

      voegtoetot:=true;
      aantalCs:=1;
      if volledigwoord then
         begin
         if controle='TO' then
            begin
            CReeks[1]:=' TO ';
            CReeks[2]:=#9'TO'#9;
            CReeks[3]:=#9'DOWNTO'#9;
            CReeks[4]:=' DOWNTO ';
            aantalCs:=4;
            end else
            begin
            CReeks[1]:=' '+controle+' ';
            CReeks[2]:=#9+controle+#9;
            AantalCs:=2;
            end;
         end
         else CReeks[1]:=controle;
      stop:=false;
      While not(EOF) and not(stop) do
        begin
        teken:=readchar;
        str:=str+teken;
        voegtoetot:=true;
        if copy(str,length(str)-1,2)=#13#10 then
           begin
           str[0]:=chr(length(str)-2);
           for teller:=1 to aantalCs do
             begin
             temp:=copy(CReeks[teller],1,length(CReeks[teller])-1);
             if (length(str)-length(temp))>0 then
                begin
                if upcstr(copy(str,1+length(str)-length(temp),length(temp)))=temp then
                   begin
                   stop:=true;
                   str[0]:=chr(length(str)-length(temp));
                   end;
                end;
             end;
           stringlist^.voegtoe(stripline(str));
           str:='';
           voegtoetot:=false;
           end;
        for teller:=1 to aantalCs do
          begin
          if (length(str)-length(Creeks[teller]))>0 then
             begin
             if upcstr(copy(str,1+length(str)-length(CReeks[teller]),length(CReeks[teller])))=CReeks[teller] then
                begin
                stop:=true;
                str[0]:=chr(length(str)-length(cReeks[teller]));
                end;
             end;
          end;
        end;
    end;


  begin

    New(stringlist,init);
    str:='VOOR';
    voegtoetot(':=',false,str);
    if (length(str)+5)>255 then
       begin
       stringlist^.voegtoe(str);
       str:='VAN ';
       end else str:=str+' VAN ';
    voegtoetot('TO',true,str);
    if (length(str)+5)>255 then
       begin
       stringlist^.Voegtoe(str);
       str:='TOT ';
       end else str:=str+' TOT ';
    if voegtoetot('DO',true,str) then stringlist^.voegtoe(str);

  end;


procedure TBlok.Onthoud;

  begin

    OPositie:=positie;
    OEOF:=EOF;
    OLW:=LaatsteWoord;
    ORem:=RemsTellenMee;

  end;


procedure TBlok.Remember;

  begin

    positie:=Opositie;
    EOF:=OEOF;
    LaatsteWoord:=OLW;
    RemsTellenMee:=ORem;

  end;


FUNCTION TBlok.VolgtPuntkomma : boolean;

  var

    stop : boolean;
    teken : char;

  begin

    Onthoud;
    Stop:=false;
    Teken:=readchar;
    while not(eof) and not(teken in woordtekens) and not(stop) do
       begin
       if teken=';' then stop:=true else teken:=readchar;
       end;
    VolgtPuntKomma:=stop;
    Remember;

  end;


PROCEDURE TBlok.TotNaPuntkomma;

  var

    stop : boolean;
    teken : char;

  begin

    Stop:=false;
    Teken:=readchar;
    while not(eof) and not(teken in woordtekens) and not(stop) do
       begin
       if teken=';' then stop:=true else teken:=readchar;
       end;

  end;


FUNCTION ReservedWord(str : string) : boolean;

  begin

    str:=strip(str);
    if (str='ELSE')        or (str='END')        or
       (str='BEGIN')       or (str='IF')         or
       (str='THEN')        or (str='CASE')       or
       (str='DOWNTO')      or (str='FOR')        or
       (str='FUNCTION')    or (str='PROCEDURE')  or
       (str='WHILE')       or (str='WITH')       or
       (str='REPEAT')      or (str='UNTIL')      or
       (str='DO')          or (str='TO')         or
       (str='CONSTRUCTOR') or (str='DESTRUCTOR')
       then reservedword:=true
       else reservedword:=false;

  end;


procedure TBlok.GoToEnd;

  begin

    repeat until strip(readword)='END';

  end;


procedure TBlok.GoToDo;

  begin

    repeat until strip(readword)='DO';

  end;


FUNCTION StripBegin(str : string) : string;

  const

    beginlijntekens = [' ', #9];

  begin

    while (length(str)<>0) and (str[1] in beginlijntekens) do delete(str,1,1);
    stripbegin:=str;

  end;


FUNCTION StripEinde(str : string) : string;

  const

    beginlijntekens = [' ', #9];

  begin

    while (length(str)<>0) and (str[length(str)] in beginlijntekens) do delete(str,length(str),1);
    stripeinde:=str;

  end;


FUNCTION StripLine(str : string) : string;

  begin

    Stripline:=StripBegin(stripeinde(str));

  end;


FUNCTION Strip(str : string) : string;

  var

    teller : byte;

  begin

    while not(str[1] in woordtekens) and (length(str)>0) do delete(str,1,1);
    while not(str[length(str)] in woordtekens) and (length(str)>0) do delete(str,length(str),1);
    for teller:=1 to length(str) do str[teller]:=upcase(str[teller]);
    Strip:=str;

  end;


PROCEDURE TBlok.LeesTotTHEN(var StringList : PStringlist);

  var

    str : string;
    onthou1 : longint;
    onthou2 : longint;
    gevonden : boolean;
    Teken    : char;

  begin

    New(StringList,init);
    onthou1:=positie;
    gevonden:=false;
    Onthou2:=onthou1;
    while not(eof) and not(gevonden) do
      begin
      if strip(readword)='THEN' then gevonden:=true else Onthou2:=positie;
      end;
    if eof then
        begin
        closegraph;
        writeln('Een IF gevonden zonder THEN !!!');
        HALT;
        end;
    positie:=onthou2;
    teken:=readchar;
    while not(teken in woordtekens) do
      begin
      onthou2:=positie;
      teken:=readchar;
      end;
    str:='';
    positie:=onthou1;
    while not(positie=onthou2) do
      begin
      str:=str+readchar;
      if length(str)=254 then
        begin
        StringList^.VoegToe(stripline(str));
        str:='';
        end;
      if (str[length(str)-1]=#13) and (str[length(str)]=#10) then
        begin
        str[0]:=chr(length(str)-2);
        str:=str+' ';
        StringList^.VoegToe(stripline(str));
        str:='';
        end;
      end;
    if length(stripline(str))<>0 then stringlist^.voegtoe(stripline(str));

  end;


PROCEDURE TBlok.LeesTotDO(var StringList : PStringlist; werkmetDO : boolean);

  var

    str : string;
    onthou1 : longint;
    onthou2 : longint;
    gevonden : boolean;
    Teken    : char;

  begin

    New(StringList,init);
    onthou1:=positie;
    gevonden:=false;
    Onthou2:=onthou1;
    while not(eof) and not(gevonden) do
      begin
      if (strip(readword)='DO') or (strip(laatstewoord)='OF') then gevonden:=true else Onthou2:=positie;
      end;
    if eof then
        begin
        closegraph;
        writeln('Een WHILE gevonden zonder DO !!!');
        writeln('of een CASE zonder OF !!!');
        HALT;
        end;
    positie:=onthou2;
    teken:=readchar;
    while not(teken in woordtekens) do
      begin
      onthou2:=positie;
      teken:=readchar;
      end;
    if werkmetdo then str:='ZOLANG' else str:='';
    positie:=onthou1;
    while not(positie=onthou2) do
      begin
      str:=str+readchar;
      if length(str)=254 then
        begin
        StringList^.VoegToe(stripline(str));
        str:='';
        end;
      if (str[length(str)-1]=#13) and (str[length(str)]=#10) then
        begin
        str[0]:=chr(length(str)-2);
        str:=str+' ';
        StringList^.VoegToe(stripline(str));
        str:='';
        end;
      end;
    if werkmetdo then
      begin
      if length(stripline(str))<>0
         then
          begin
          if length(stripline(str))<251
            then stringlist^.voegtoe(stripline(str)+' DOE')
            else
              begin
              stringlist^.voegtoe(stripline(str));
              stringlist^.voegtoe(' DOE');
              end;
          end
         else stringlist^.voegtoe(' DOE');
      end else
        begin
        if length(stripline(str))<>0 then stringlist^.voegtoe(stripline(str));
        end;

  end;


FUNCTION TBlok.VolgendWoord : string;

  begin

    OntHoud;
    Volgendwoord:=readword;
    Remember;

  end;


FUNCTION TBLok.TotEindeLijn : string;

  var

    eindebereikt : boolean;
    str : string;

  begin

    str:='';
    eindebereikt:=false;
    while not(EOF) and not(eindebereikt) do
      begin
      str:=str+Readchar;
      if (str[length(str)]=#10) and (str[length(str)-1]=#13) then eindebereikt:=true;
      end;
    if eindebereikt then str[0]:=chr(length(str)-2);
    totEindeLijn:=str;

  end;


FUNCTION TBlok.SPecVolgendWoord : string;

  var

    stop : boolean;
    teken : char;
    str : string;

  begin

    OntHoud;
    stop:=false;
    str:='';
    if not(eof) then str:=readchar;
    while not(eof) and not(stop) do
       begin
       teken:=readchar;
       if teken in woordtekens then str:=str+teken
       else stop:=true;
       end;
    if (length(str)<>0) and ((str[1] in woordtekens) or (str[1]=#39))
       then str:=''
       else delete(str,1,1);
    SpecVolgendWoord:=str;
    Remember;

  end;


PROCEDURE TBlok.Done;

  begin

    Close(Bestand);

  end;


PROCEDURE TBLok.ReadTotPuntKomma(tekstToeTeVoegen : string; var StringList : PStringlist; IsPuntKomma : boolean);

  var

    teken            : char;
    aantalhaken      : byte;
    str              : string;
    intekst          : boolean;
    haaktegengekomen : boolean;
    HaakOpener       : boolean;
    EersteKeer       : boolean;
    EersteTeken      : boolean;
    stoppen          : boolean;
    regelvol         : boolean;
    vwig             : boolean;

  begin

    new(stringlist,init);
    aantalhaken:=0;
    remstellenmee:=false;
    intekst:=false;
    teken:=readchar;
    haaktegengekomen:=false;
    eerstekeer:=true;
    HaakOpener:=false;
    vwig:=false;
    repeat
      if eerstekeer then str:=teksttoetevoegen else str:='';
      regelvol:=false;
      stoppen:=true;
      eersteteken:=true;
      while not(regelvol) and (not eof) and
      (not(haakopener) or (not(haaktegengekomen))) and
      (haakopener or not(vwig)) do
        begin
        if not intekst
           then
             begin
             if (ispuntkomma and (teken=';')) or (not(ispuntkomma) and (teken=':')) then
                begin
                haakopener:=true;
                haaktegengekomen:=true;
                if teken=':' then teken:=' ';
                end;
             if teken=#39 then
                begin
                Intekst:=true;
                vwig:=false;
                RemsTellenMee:=true;
                end else
                  begin
                  if ispuntkomma then vwig:=ReservedWord(SpecVolgendWoord) else vwig:=false;
                  end;
             end
           else
             begin
             if teken=#39 then
                begin
                intekst:=false;
                remstellenmee:=false;
                end;
             end;
        if eerstekeer and (length(str)=0) and (teken=';') and not(ispuntkomma) then
           begin
           str:=#13#10;
           end else str:=str+teken;
        if (str[length(str)]=#10) and (str[length(str)-1]=#13) then
           begin
           str[0]:=chr(length(str)-2);
           if not(eerstekeer and (length(str)=0)) then
             begin
             regelvol:=true;
             stoppen:=false;
             end;
           end;
        if length(str)=254 then
           begin
           regelvol:=true;
           stoppen:=false;
           end;
        if not(teken in [' ',#9]) then eersteteken:=false;
        teken:=readchar;
        end;
      if (length(str)>0) and (str[length(str)]=#13) then str[0]:=chr(length(str)-1);
      StringList^.voegtoe(stripBegin(str));
      if eof then stoppen:=true;
      eerstekeer:=false;
    until stoppen;
    if ispuntkomma and volgtpuntkomma then totnapuntkomma;
    positie:=positie-1;
    remstellenmee:=false;

  end;


FUNCTION TBlok.ReadWord : string;

  var

    str : string;
    teken : char;

  begin

    teken:=readchar;
    str:='';
    while (not(teken in WoordTekens)) and (not EOF) do teken:=readchar;
    if EOF then
       begin
       readword:='';
       exit;
       end;
    str:=str+teken;
    teken:=readchar;
    while (teken in WoordTekens) and (not EOF) do
      begin
      str:=str+teken;
      teken:=readchar;
      end;
    if EOF and (teken in woordTekens) then str:=str+teken;
    if not EOF then positie:=positie-1;
    laatstewoord:=str;
    readword:=str;

  end;


PROCEDURE TBlok.ReadTotNaImplementation;

  begin

    while not(strip(readword)='IMPLEMENTATION') do ;

  end;


FUNCTION TBlok.ReadChar : char;

  var

    teken : char;
    volgendteken : char;

  begin

    Seek(bestand,positie);
    read(bestand,teken);
    positie:=positie+1;
    if positie<filesize then read(bestand,volgendteken) else volgendteken:='~';
    if not remstellenmee and ((teken='{') or ((teken='(') and (volgendteken='*'))) then
       begin
       if teken='{' then positie:=positie+1 else positie:=positie+2;
       while (positie<filesize) and (teken<>'}') and not((teken='*') and (volgendteken=')')) do
         begin
         seek(bestand,positie);
         read(bestand,teken);
         read(bestand,volgendteken);
         positie:=positie+1;
         end;
       if positie<filesize then
          begin
          if (teken='*') and (volgendteken=')') then
            begin
            seek(bestand,positie);
            read(bestand,teken);
            if positie<filesize then read(bestand,teken);
            positie:=positie+2;
            end else
            begin
            seek(bestand,positie);
            read(bestand,teken);
            positie:=positie+1;
            end;
          end;
       end;
    EOF:=false;
    if positie>=FileSize then
       begin
       EOF:=true;
       positie:=FileSize-1;
       end;
    readchar:=teken;

  end;


PROCEDURE TBLok.Reset(IPad : pathstr);

  begin

    Assign(bestand,IPad);
    system.Reset(bestand);
    positie:=0;
    filesize:=system.filesize(bestand);
    EOF:=false;
    remstellenmee:=false;
    if positie>=filesize then
       begin
       EOF:=true;
       positie:=filesize-1;
       end;

  end;

END.
