UNIT Taal;
{$D-,X+}


                                INTERFACE


USES

  App,
  Dos,
  Views,
  Printer,
  MsgBox2,
  Dialogs,
  Drivers,
  Objects,
  Stddlg2,
  P2NHelp,
  P2ninst2;

TYPE

  PRegel = ^TRegel;
  TRegel = object
           tekst : PString;
           constructor init(str : string);
           destructor done;
           end;
  PTaalView = ^TTaalView;
  TTaalView = object(TView)
              pad : pathstr;
              gegevens : PCollection;
              cursorpositie  : longint;
              taalveranderd : boolean;
              Xpos : byte;
              constructor init(bounds : TRect; Ipad : pathstr);
              procedure HandleEvent(var event : Tevent); virtual;
              procedure draw; virtual;
              function Save : boolean;
              function SaveAs : boolean;
              function Valid(Command: Word): Boolean; virtual;
              procedure Print;
              private
                function SaveHetuiteindelijk(Ipad : pathstr) : boolean;
              end;
  PInputStatement = ^TInputStatement;
  TInputStatement = object(TInputLine)
                    constructor init(bounds : TRECt);
                    procedure HandleEvent(var event : tevent); virtual;
                    end;
  PTaalWindow = ^TTaalWindow;
  TTaalWindow = object(TWindow)
                houder : PTaalView;
                indicator : PIndicator;
                constructor init(bounds : TRect; IPad : pathstr);
                procedure HandleEvent(var event : TEvent); virtual;
                procedure SetState(AState: Word; Enable: Boolean); virtual;
                destructor done; virtual;
                end;


VAR

  TaalNummer     : byte;


                        IMPLEMENTATION


(***************************************************************)
(*                                                             *)
(*                    TInputStatement                          *)
(*                                                             *)
(***************************************************************)
constructor TInputStatement.Init(bounds : TRect);

  begin

    TInputline.init(bounds,63);

  end;


procedure TInputStatement.HandleEvent(var event : TEvent);

  var

    newevent : TEvent;

  begin

    if (event.what=evKeyDown) and (event.charcode=' ') then
      begin
      ClearEvent(event);
      NewEvent.what:=evKeyDown;
      NewEvent.keycode:=kbTab;
      PutEvent(NewEvent);
      end else TInputline.HandleEvent(event);

  end;


(***************************************************************)
(*                                                             *)
(*                    TRegel                                   *)
(*                                                             *)
(***************************************************************)
constructor TRegel.init(str : string);

  begin

    tekst:=NewStr(Str);
    if tekst=nil then fail;

  end;


destructor TRegel.done;

  begin

    disposestr(tekst);

  end;


(***************************************************************)
(*                                                             *)
(*                    TTaalWindow                              *)
(*                                                             *)
(***************************************************************)
constructor TTaalWindow.init(bounds : TRect; IPad : pathstr);

  var

    R : TRect;
    str : string;

  begin

    inc(windownummer);
    if Ipad='' then
       begin
       inc(taalnummer);
       str:=Byte2str(taalnummer);
       end else str:=IPad;
    TWindow.init(bounds,'Taal '+str,windownummer);
    helpctx:=hcTaalWindow;
    R.A.Y:=size.Y-1;
    R.A.X:=1;
    R.B.X:=4;
    R.B.Y:=size.Y;
    indicator:=new(PIndicator,init(R));
    twindow.insert(indicator);
    R.A.Y:=1;
    R.A.X:=1;
    R.B.X:=size.X-1;
    R.B.Y:=size.Y-1;
    enablecommands(csWindowAfhankelijk);
    houder:=new(PTaalView,init(R,Ipad));
    TWindow.insert(houder);

  end;


procedure TTaalWindow.SetState(AState: Word; Enable: Boolean);

  begin

    Twindow.SetState(AState,enable);
    if not(enable) and ((Astate and sfSelected) = sfSelected)
      then Indicator^.hide
      else
        begin
        Indicator^.show;
        Enablecommands(csWindowAfhankelijk);
        end;

  end;


destructor TTaalWindow.done;

  begin

    Twindow.done;
    disablecommands(csWindowAfhankelijk);

  end;


procedure TTaalWindow.HandleEvent(var event : tevent);

  procedure taalisveranderd;

    begin

      indicator^.setValue(true);
      clearevent(event);

    end;


  procedure taalisnietveranderd;

    begin

      indicator^.setValue(false);
      disposestr(title);
      title:=newstr(Pstring(event.infoptr)^);
      frame^.drawview;
      clearevent(event);

    end;


  begin

    Twindow.HandleEvent(event);
    if event.what<>evnothing then houder^.HandleEvent(event);
    case event.what of
      evBroadCast : begin
                    case event.Command of
                      cmVeranderd : TaalIsVeranderd;
                      cmNietVeranderd : TaalIsNietVeranderd;
                      end;
                    end;
      end;

  end;


(***************************************************************)
(*                                                             *)
(*                    TTaalView                                *)
(*                                                             *)
(***************************************************************)
constructor TTaalView.init(Bounds : TRect; Ipad : pathstr);

  var

    str : string;
    blok : TBlok;
    RO : TRect;
    RR : Trect;

  begin

    TView.Init(bounds);
    pad:=IPad;
    Xpos:=1;
    cursorpositie:=0;
    growmode:=gfGrowHiX+gfGrowHiY;
    options:=ofFramed;
    taalveranderd:=false;
    gegevens:=new(PCollection,init(10,5));
    if pad<>'' then
       begin
       Blok.reset(pad);
       while not blok.eof do gegevens^.insert(new(PRegel,init(blok.Toteindelijn)));
       gegevens^.pack;
       blok.done;
       end;

  end;


procedure TTaalView.HandleEvent(var event : TEvent);

  type

    TData = record
            statement : string[63];
            vertaling : string[128];
            end;

  procedure NietVeranderd;

    begin

      message(owner,evbroadcast,cmNietVeranderd,@pad);
      taalveranderd:=false;

    end;


  procedure verandert;

    begin

      if not taalveranderd then
        begin
        message(owner,evbroadcast,cmVeranderd,nil);
        taalveranderd:=true;
        end;

    end;


  procedure DoBalkDown;

    begin

      if cursorpositie<gegevens^.count then inc(CursorPositie);
      drawview;
      clearevent(event);

    end;


  procedure DoBalkUp;

    begin

      if cursorpositie>0 then dec(cursorpositie);
      drawview;
      clearevent(event);

    end;


  procedure DoWeg;

    begin

      if cursorpositie<gegevens^.count then
        begin
        gegevens^.atdelete(cursorpositie);
        Verandert;
        drawview;
        end;
      clearevent(event);

    end;


  procedure VeranderData(var data : TData);

    var

      D : PDialog;
      R : TRect;
      oorspronkelijkeData : TData;
      stop : boolean;

    begin

      OorspronkelijkeData:=Data;
      R.assign(10,10,60,20);
      D:=new(PDialog,init(R,'invoegen regel'));
      R.Assign(2,2,14,3);
      D^.insert(new(PStaticText,init(R,'Statement : ')));
      R.Assign(14,2,34,3);
      D^.insert(new(PInputStatement, init(R)));
      R.Assign(2,4,14,5);
      D^.insert(new(PStaticText,init(R,'Vertaling : ')));
      R.Assign(14,4,34,5);
      D^.insert(new(PInputline, init(R,128)));
      R.assign(2,6,22,8);
      D^.insert(new(Pbutton, init(R,'~O~K', cmOK, bfdefault)));
      R.Assign(27,6,47,8);
      D^.insert(new(PButton, init(R,'~C~ancel', cmCancel, bfNormal)));
      D^.setdata(data);
      D^.selectnext(false);
      D^.helpctx:=hcInsertDialog;
      repeat
      if desktop^.execview(D)=cmOK then
        begin
        D^.Getdata(data);
        stop:=true;
        if reservedword(strip(data.statement)) then
          begin
          stop:=false;
          messagebox('Jij gaat de gereserveerde woorden vertalen, lolbroek !', nil, mfError+mfOKbutton);
          data:=oorspronkelijkeData;
          end;
        if stop and (strip(data.statement)='') then
          begin
          stop:=false;
          messagebox('misschien is het interresant als ik zeg dat ik niet weet wat ik moet vertalen !',
          nil, mfError + mfOKButton);
          data:=oorspronkelijkeData;
          end;
        end else stop:=true;
      until stop;
      dispose(D,done);

    end;


  procedure insertdata(data : TData);

    var

      mix : string;
      temp : string;
      punter : pointer;

    begin

      clearevent(event);
      fillchar(mix,256,' ');
      mix:=data.statement;
      if length(mix)<20 then mix[0]:=#20;
      mix:=mix+' '+data.vertaling;
      if strip(mix)<>'' then
         begin
         gegevens^.atinsert(cursorpositie,new(PRegel,init(mix)));
         inc(cursorpositie);
         drawview;
         verandert;
         end;

    end;


  procedure DoInsert;

    var

      data : TData;
      mix  : string;

    begin

      data.statement:='';
      data.vertaling:='';
      VeranderData(data);
      insertdata(data);

    end;


  procedure doveranderregel;

    var

      data : TData;
      mix : string;
      deel1 : string;
      deel2 : string;

    begin

      if cursorpositie=gegevens^.count then doinsert else
        begin
        deel1:=data.statement;
        deel2:=data.vertaling;
        splits(PRegel(gegevens^.at(cursorpositie))^.tekst^, deel1 , deel2);
        data.statement:=deel1;
        data.vertaling:=deel2;
        veranderdata(data);
        gegevens^.atdelete(cursorpositie);
        insertdata(data);
        end;

    end;


  procedure GoListEnd;

    begin

      cursorpositie:=gegevens^.count;
      drawview;
      clearevent(event);

    end;


  procedure StijgScherm;

    begin

      dec(cursorpositie,size.Y);
      if cursorpositie<0 then cursorpositie:=0;
      drawview;
      clearevent(event);

    end;


  procedure DaalScherm;

    begin

      inc(cursorpositie,size.Y);
      if cursorpositie>gegevens^.count then cursorpositie:=gegevens^.count;
      drawview;
      clearevent(event);

    end;


  procedure GoListStart;

    begin

      cursorpositie:=0;
      drawview;
      clearevent(event);

    end;


  begin

    TView.HandleEvent(event);
    case event.what of
      evKeyDown : begin
                  case event.keycode of
                    kbDown : DoBalkDown;
                    kbUp : DoBalkUp;
                    kbIns : DoInsert;
                    kbDel : DoWeg;
                    kbEnter : DoVeranderRegel;
                    kbEnd, kbCtrlPgDn : GoListEnd;
                    kbHome, kbCtrlPgUp : GoListStart;
                    kbPgUp : StijgScherm;
                    kbPgDn : DaalScherm;
                    end;
                  end;
      evCommand : begin
                  case event.Command of
                    cmSave : if Save then NietVeranderd else clearevent(event);
                    cmPrint : Print;
                    cmSaveAs : if Saveas then NietVeranderd else clearevent(event);
                    end;
                  end;
      end;

  end;


procedure TTaalView.Draw;

  var

    str : string;
    huidigepositie : longint;
    PStr : Pstring;
    Yteller : byte;

  begin

    huidigepositie:=cursorpositie;
    huidigepositie:=huidigepositie-(size.Y div 2);
    if huidigepositie<0 then huidigepositie:=0;
    if (huidigepositie-1+size.Y)>gegevens^.count then
    huidigepositie:=gegevens^.count-size.Y+1;
    if huidigepositie<0 then huidigepositie:=0;
    for YTeller:=0 to size.Y do
      begin
      fillchar(str,256,' ');
      if (huidigepositie+Yteller)<(gegevens^.count) then
        begin
        Pstr:=Pregel(gegevens^.at(huidigepositie+Yteller))^.tekst;
        if PStr=nil then Str:='' else str:=Pstr^;
        end;
      str[0]:=chr(size.X);
      if huidigepositie+Yteller=CursorPositie
        then Writestr(0,YTeller,str,7)
        else Writestr(0,YTeller,str,6);
      end;

  end;


function TTaalView.SaveHetUiteindelijk(Ipad : pathstr) : boolean;

    var

      bestand : text;
      teller : longint;

    begin

      pad:=Ipad;
      system.Assign(bestand,pad);
      system.Rewrite(bestand);
      for teller:=0 to gegevens^.count-1 do
      system.Writeln(bestand,PRegel(gegevens^.at(teller))^.Tekst^);
      system.close(bestand);
      TaalVeranderd:=true;
      savehetuiteindelijk:=true;

    end;


function TTaalView.SaveAs : boolean;

    var

      filename : pathstr;

    begin

      saveas:=false;
      filename:='*.*';
      case ExecDialog(New(PFileDialog, Init('*.*', 'Save '+PWindow(owner)^.title^+' als',
      '~N~aam', fdSaveButton, 100)), @FileName) of
      cmCancel : exit;
      else
        begin
        if fileexists(filename) then
          begin
          if Messagebox('De file '+filename+' bestaat reeds, '+
          'toch overschrijven',nil,mfYesButton+mfNoButton+
          mfWarning)<>cmYes then exit;
          end;
        saveas:=SaveHetuiteindelijk(filename);
        end;
      end;
    end;


function TTaalView.Save : boolean;

    begin

      save:=false;
      if TaalVeranderd then
         begin
         if Pad=''
           then save:=saveas
           else save:=SaveHetuiteindelijk(pad);
         end;

    end;


function TTaalView.Valid(Command: Word): Boolean;

  begin

    Valid:=true;
    case Command of
     cmQuit, cmClose : begin
                       if taalveranderd then
                         begin
                         case messagebox('De reeks vertalingen in ' + PWindow(owner)^.title^ +
                         ' is verandert. Save''n ?', nil, mfWarning+mfYesButton+mfNoButton+mfCancelButton) of
                           cmYes : save;
                           cmCancel : valid:=false;
                           end;
                         end;
                       end;
     end;

  end;


procedure TTaalView.print;

  var

    teller : Longint;
    gelukt : boolean;

  begin

    {$I-}
    for teller:=0 to gegevens^.count do
      begin
      gelukt:=false;
      while not(gelukt) do
        begin
        if teller=gegevens^.count
          then write(lst,#12)
          else writeln(lst, Pregel(gegevens^.at(teller))^.tekst^);
        if IOResult<>0 then
           begin
           if Syserrorfunc(14,0)=1 then exit else gelukt:=false;
           end else gelukt:=true;
        end;
      end;
    {$I+}

  end;

END.
