UNIT Algemeen;
{$X+,V-}

                                INTERFACE

USES

  Crt,
  Dos,
  Objects,
  Graph;


CONST

  {De kleuren van de desktop}
    Desktop : word = Blue;
  {De kleuren als er errors moeten verschijnen}
    ErrorFg  : word= yellow;
    ErrorBg  : word= red;
  {De kleuren van de vragen}
    VraagFg  : word= yellow;
    VraagBg  : word= Cyan;
    VraagDoneFg : word = Yellow;
    VraagDoneBg : word = Blue;
  {De kleuren van de file-selectie}
    FileFg : word = LightRed;
    Rand : word = white;
    FileBg : word = Black;
    SelFileFg : word = Yellow;
    SelFileBg : word = Blue;
  {De kleuren van de infokader}
    InfoBg : word = magenta;
    InfoFg : word = White;
  {De diagram-kleur}
    Diagrammen : word = LightCyan;

TYPE

  PString = ^String;
  PFile=^TFile;
  TFile=object(tobject)
    Attr : byte;
    Name : fNameStr;
    constructor init(AName : FNamestr; AnAttr : byte);
    end;
  PFileCollection = ^TFileCollection;
  TFileCollection = object(tsortedcollection)
    function Compare(Key1, Key2: Pointer): Integer; virtual;
    end;
  PVileList = ^TVileList;
  TVilelist = object
    CurDir : dirstr;
    hoogte : integer;
    kolommen : integer;
    Topitem : integer;
    Item : integer;
    boveny, ondery : integer;
    Pad : pathstr; {het huidig geselecteerde item}
    Gedaan : boolean;
    List : PFileCollection;
    constructor init(YBoven, YBeneden : integer);
    procedure Draw;
    procedure ChangeDrive(Naar : char);
    procedure RedrawItem(Welk : integer);
    procedure ChangeDir(VolgensItem : integer);
    function MaakSelection : pathstr;
    procedure ReadCurDir;
    procedure move(DX,DY : integer);
    destructor done;
    end;

procedure makescreen;
procedure MoveUp;
Function Int2Str(L : LongInt) : string;
PROCEDURE ErrorAt(X,Y : integer; Tekst : string);
PROCEDURE PrintFilesNaarPrinter(titel : string);
PROCEDURE PressAnyKey;
PROCEDURE SwitchMono;
FUNCTION GetOneFile(titel : string) : pathstr;
PROCEDURE OverWriteAt(X,Y : integer;Fg,Bg : word; str : string);
FUNCTION Vraagstr(Tekst : string) : string;
FUNCTION VraagJaNee(tekst : string; voorkeur : boolean) : boolean;
FUNCTION VraagInteger(tekst : String; van, tot : Integer) : Integer;
FUNCTION Driesprong(tekst, keuze1, keuze2, keuze3 : string; voorkeur : byte) : byte;
FUNCTION VierSprong(tekst, keuze1, keuze2, keuze3, keuze4 : string; voorkeur : byte) : byte;
FUNCTION DirExists(dir : dirstr) : boolean;
FUNCTION FileExists(pad : pathstr) : boolean;
FUNCTION DestilleerDir(pad : pathstr) : dirstr;
FUNCTION DatumStr : string;
FUNCTION HeapFunc(Size: word): Integer;

type

  teksten = (NIETS, KEUZE, STANDAARD);

CONST

  TekstVoordiagram  : teksten = standaard;
  TekstNaDiagram    : teksten = standaard;
  TekstVoorDocument : boolean = false;
  EersteProgramma   : boolean = true;

VAR

  programmahoofding : string;


                                IMPLEMENTATION


USES

  Printer2;

procedure makescreen;

  begin

    SetFillStyle(Solidfill,Desktop);
    Bar(0,0,Getmaxx,getmaxy);
    MoveTo(GetX,12);

  end;


procedure MoveUp;

  begin

    if not(GetY>((GetmaxY*2) div 3)) then exit;
    MoveTo(GetX,12);
    SetFillStyle(Solidfill,Desktop);
    Bar(0,0,getmaxx,getmaxy);

  end;


PROCEDURE LastBackSlash(var AStr : Dirstr);

  begin

    if astr[byte(astr[0])]<>'\' then astr:=astr+'\';

  end;


constructor TFile.init;

  begin

    TObject.Init;
    Name:=aname;
    Attr:=AnAttr;
    if ((attr and directory)<>0) and (name<>'..') and (name<>'.') then Name:=Name+'\';

  end;


function TFileCollection.Compare(Key1, Key2: Pointer): Integer;

  begin

    If ((PFile(Key1)^.Attr and directory)<>0) and ((PFile(Key2)^.Attr and directory)=0)
      then compare:=-1
      else
        begin
        If ((PFile(Key1)^.Attr and directory)=0) and ((PFile(Key2)^.Attr and directory)<>0)
          then compare:=1
          else
            begin
            If PFile(Key1)^.Name<PFile(Key2)^.Name
              then Compare:=-1
              else Compare:=byte(PFile(Key1)^.Name>PFile(Key2)^.Name);
            end;
        end;

  end;


constructor TVileList.init(YBoven, YBeneden : integer);

  begin

    Pad:='';
    GetDir(0,CurDir);
    LastBackSlash(curdir);
    gedaan:=false;
    BovenY:=YBoven;
    OnderY:=YBeneden;
    List:=new(PFileCollection,init(0,1));
    Hoogte:=(OnderY-BovenY-24) div 12;
    kolommen:=(getmaxx-24) div (13*8)+1;
    ReadCurDir;

  end;


Function DriveValid(Drive: Char): Boolean; assembler;

  asm
	MOV     DL,Drive
	MOV     AH,36H
	SUB     DL,'A'-1
	INT     21H
	INC     AX
	JE      @@2
  @@1:  MOV     AL,1
  @@2:

  end;


procedure TVileList.ChangeDrive(Naar : char);

  begin

    If not drivevalid(Naar) then exit;
    GetDir(ord(Naar)-64,CurDir);
    LastBackSlash(curdir);
    ReadCurDir;

  end;


procedure TVileList.ChangeDir;

  var

    n : fnamestr;

  begin

    N:=PFile(List^.At(VolgensItem))^.Name;
    If N='..'
      then
        begin
        dec(CurDir[0]);
        FSplit(CurDir,Curdir,n,n);
        end
      else
        begin
        if N='.' then exit;
        curdir:=curdir+N;
        end;
    LastBackSlash(curdir);
    ReadCurDir;

  end;


procedure TVileList.Move;

  var

    olditem : integer;

  begin

    {Eerst verplaatsen van de cursor}
    Olditem:=item;
    Item:=Item+DX*Hoogte+DY;
    {Controle op grenzen}
    If Item<0 then Item:=0;
    If Item>=List^.count then Item:=List^.Count-1;
    {Eventueel nieuw scherm, anders hertekenen van de rest}
    If Topitem+Kolommen*hoogte<=Item
      then
        begin
        Topitem:=topitem+kolommen*hoogte;
        draw;
        end
      else
        begin
        If TopItem>Item
          then
            begin
            Topitem:=Topitem-kolommen*hoogte;
            If topitem<0 then topitem:=0;
            draw;
            end
          else
            begin
            RedrawItem(OldItem);
            RedrawItem(Item);
            end;
        end;
    Pad:=CurDir+PFile(List^.At(Item))^.Name;

  end;


function TVileList.MaakSelection : pathstr;

  var

    ok : boolean;
    teken : char;

  begin

    ok:=false;
    repeat
      teken:=readkey;
      case teken of
        #27 : begin
              gedaan:=true;
              exit;
              end;
        #13 : begin
              If (PFile(list^.At(Item))^.Attr and directory)<>0
                then ChangeDir(item)
                else ok:=true;
              end;
        #0 : case readkey of
               #77 : Move(+1,0);
               #75 : Move(-1,0);
               #80 : Move(0,+1);
               #72 : Move(0,-1);
               end;
        else
          begin
          teken:=upcase(teken);
          if (teken>='A') and (teken<='Z') then ChangeDrive(teken);
          end;
        end;
    until ok;

  end;


procedure TVileList.RedrawItem;

  var

    X,Y : integer;

  begin

    Y:=Welk-Topitem;
    X:=Y div Hoogte;
    Y:=(Y-X*hoogte)*12+BovenY+12;
    X:=x*13*8+8;
    if item=welk
      then OverWriteAt(X,Y,SelFileFg,SelFileBg,PFile(List^.At(welk))^.Name)
      else OverWriteAt(X,Y,FileFg,FileBg,PFile(List^.At(welk))^.Name);

  end;


procedure TVileList.Draw;

  var

    last : integer;
    teller : integer;

  begin

    SetFillStyle(solidfill,FileBg);
    Bar(0,BovenY,getmaxx,OnderY);
    SetColor(Rand);
    Line(2,BovenY+2,getmaxx-6,BovenY+2);
    Line(2,OnderY-2,getmaxx-6,OnderY-2);
    Line(2,BovenY+2,2,OnderY-2);
    Line(getmaxx-6,BovenY+2,getmaxx-6,OnderY-2);
    OverWriteAt(4*8,BovenY,Rand,FileBg,CurDir);
    Teller:=TopItem;
    Last:=topitem+kolommen*hoogte;
    while (teller<list^.count) and (teller<last) do
      begin
      RedrawItem(Teller);
      inc(teller);
      end;

  end;


procedure TVileList.ReadCurDir;

  var

    R : searchrec;

  begin

    FindFirst(CurDir+'*.*',anyfile,R);
    List^.FreeAll;
    while doserror=0 do
      begin
      if (R.Attr and VolumeId)=0 then List^.Insert(new(PFile,init(R.Name,R.Attr)));
      FindNext(R);
      end;
    Pad:=CurDir+PFile(List^.At(0))^.Name;
    TopItem:=0;
    Item:=0;
    if curdir[0]>#3
      then
        begin
        dec(curdir[0]);
        ChDir(CurDir);
        Inc(curdir[0]);
        end
      else ChDir(CurDir);
    Draw;

  end;


destructor TVileList.done;

  begin

    SetFillStyle(solidfill,desktop);
    Bar(0,BovenY,GetmaxX,OnderY);
    Dispose(list,done);

  end;


procedure pressanykey;

  begin

    While keypressed do readkey;
    repeat until keypressed;
    While keypressed do readkey;

  end;


Function Int2Str(L : LongInt) : string;

  var

    S : string;

  begin

    Str(L, S);
    Int2Str := S;

  end; 


PROCEDURE ErrorAt(X,Y : integer; Tekst : string);

  var

    grootte :integer;
    Naar : pointer;

  begin

    Grootte:=ImageSize(X,Y,X+2+length(tekst)*8,Y+23);
    Getmem(Naar,grootte);
    GetImage(X,Y,X+2+length(tekst)*8,Y+23,naar^);
    OverWriteAt(X,Y,ErrorFg,ErrorBg,tekst);
    OverWriteAt(X,Y+12,ErrorFg,ErrorBg,'Press any key...');
    PressAnyKey;
    PutImage(X,Y,naar^,copyput);
    FreeMem(Naar,grootte);

  end;



PROCEDURE OverWriteAt(X,Y : integer;Fg,Bg : word; str : string);

  begin

    SetFillSTyle(SolidFill,Bg);
    Bar(X,Y,X+2+8*length(str),Y+11);
    SetColor(Fg);
    OutTextXY(X+1,Y+2,Str);

  end;


FUNCTION FileExists(pad : pathstr) : boolean;

  var

    rommelrec : searchrec;

  begin

    if (pos('*',pad)=0) and (pos('?',pad)=0) then
       begin
       findfirst(pad,archive,rommelrec);
       if doserror=0 then
          begin
          FileExists:=true;
          exit;
          end;
       end;
    FileExists:=false;

  end;


FUNCTION DatumStr : string;

  CONST

    days : array [0..6] of String[9] =('Zondag','Maandag','Dinsdag',
                                       'Woensdag','Donderdag','Vrijdag',
                                       'Zaterdag');

  VAR

    Y, M, D, DOW : Word;

  FUNCTION NaarStr(waarde : word) : string;

    var

      str : string;

    begin

      system.str(waarde,str);
      Naarstr:=str;

    end;


  BEGIN

    GetDate(y,m,d,dow);
    DatumStr:=days[dow]+', '+Naarstr(d)+ '/'+Naarstr(m)+'/'+naarstr(y);

  end;


FUNCTION DestilleerDir(pad : pathstr) : dirstr;

  var

    N : NameStr;
    E : ExtStr;
    D : DirStr;

  begin

    if (Pos('*',pad)<>0) or (Pos('?',pad)<>0) then
       begin
       Fsplit(Pad,D,N,E);
       DestilleerDir:=D;
       end else destilleerdir:=pad;

  end;


FUNCTION Driesprong(tekst, keuze1, keuze2, keuze3 : string; voorkeur : byte) : byte;

  var

    stx,sty : integer;
    stop : boolean;
    str : string;
    eerstekeer : boolean;
    start : byte;
    PijlLeft : char;
    PijlRight : char;
    keuze     : byte;


  procedure ZetPijl;

     begin

       PijlLeft:=#16;
       PijlRight:=#17;

     end;


  procedure ClearPijl;

    begin

      Pijlleft:=' ';
      PijlRight:=' ';

    end;


  begin

    MoveUp;
    StX:=getx;
    stY:=getY;
    OverWriteAt(stx,sty,VraagFg,VraagBg,tekst);
    keuze:=voorkeur;
    eerstekeer:=true;
    stop:=false;
    repeat
      if keuze=1 then ZetPijl else clearpijl;
      OverWriteAt(Stx+40,sty+12,vraagfg,vraagbg,pijlleft+' 1. '+keuze1+' '+pijlRight);
      if keuze=2 then ZetPijl else clearpijl;
      OverWriteAt(Stx+40,sty+24,vraagfg,vraagbg,pijlleft+' 2. '+keuze2+' '+pijlRight);
      if keuze=3 then ZetPijl else clearpijl;
      OverWriteAt(Stx+40,sty+36,vraagfg,vraagbg,pijlleft+' 3. '+keuze3+' '+pijlRight);
      case readkey of
        #13 : stop:=true;
        #27 : ;
        '1' : keuze:=1;
        '2' : keuze:=2;
        '3' : keuze:=3;
        #0  : begin
              case readkey of
                #72 : begin
                      keuze:=keuze-1;
                      if keuze=0 then keuze:=3;
                      end;
                #80 : begin
                      keuze:=keuze+1;
                      if keuze>3 then keuze:=1;
                      end;
                end;
              end;
        end;
      start:=whereY-3;
      eerstekeer:=false;
    until stop;
    Driesprong:=keuze;
    OverWriteAt(stx,sty,VraagDoneFg,VraagDoneBg,tekst);
    if keuze=1 then ZetPijl else clearpijl;
    OverWriteAt(Stx+40,sty+12,vraagdonefg,vraagdonebg,pijlleft+' 1. '+keuze1+' '+pijlRight);
    if keuze=2 then ZetPijl else clearpijl;
    OverWriteAt(Stx+40,sty+24,vraagdonefg,vraagdonebg,pijlleft+' 2. '+keuze2+' '+pijlRight);
    if keuze=3 then ZetPijl else clearpijl;
    OverWriteAt(Stx+40,sty+36,vraagdonefg,vraagdonebg,pijlleft+' 3. '+keuze3+' '+pijlRight);
    MoveTo(Stx,Sty+48);

  end;


FUNCTION VierSprong(tekst, keuze1, keuze2, keuze3, keuze4 : string; voorkeur : byte) : byte;

  var

    xst,yst : integer;
    stop : boolean;
    eerstekeer : boolean;
    start : byte;
    PijlLeft : char;
    PijlRight : char;
    keuze     : byte;


  procedure ZetPijl;

     begin

       PijlLeft:=#16;
       PijlRight:=#17;

     end;


  procedure ClearPijl;

    begin

      Pijlleft:=' ';
      PijlRight:=' ';

    end;


  begin

    MoveUp;
    xst:=getx;
    yst:=gety;
    Overwriteat(XSt,YSt,VraagFg,VraagBg,tekst);
    keuze:=voorkeur;
    eerstekeer:=true;
    stop:=false;
    repeat
      if not eerstekeer then gotoxy(1,start);
      if keuze=1 then ZetPijl else clearpijl;
      OverwriteAt(XSt+40,YSt+12,VraagFg,VraagBg,pijlleft+' 1. '+keuze1+' '+pijlRight);
      if keuze=2 then ZetPijl else clearpijl;
      OverwriteAt(XSt+40,YSt+24,VraagFg,VraagBg,pijlleft+' 2. '+keuze2+' '+pijlRight);
      if keuze=3 then ZetPijl else clearpijl;
      OverwriteAt(XSt+40,YSt+36,VraagFg,VraagBg,pijlleft+' 3. '+keuze3+' '+pijlRight);
      if keuze=4 then ZetPijl else clearpijl;
      OverwriteAt(XSt+40,YSt+48,VraagFg,VraagBg,pijlleft+' 4. '+keuze4+' '+pijlRight);
      case readkey of
        #13 : stop:=true;
        #27 : ;
        '1' : keuze:=1;
        '2' : keuze:=2;
        '3' : keuze:=3;
        '4' : keuze:=4;
        #0  : begin
              case readkey of
                #72 : begin
                      keuze:=keuze-1;
                      if keuze=0 then keuze:=4;
                      end;
                #80 : begin
                      keuze:=keuze+1;
                      if keuze>4 then keuze:=1;
                      end;
                end;
              end;
        end;
      start:=whereY-4;
      eerstekeer:=false;
    until stop;
    VierSprong:=keuze;
    Overwriteat(XSt,YSt,VraagDoneFg,VraagDoneBg,tekst);
    if keuze=1 then ZetPijl else clearpijl;
    OverwriteAt(XSt+40,YSt+12,VraagDoneFg,VraagDoneBg,pijlleft+' 1. '+keuze1+' '+pijlRight);
    if keuze=2 then ZetPijl else clearpijl;
    OverwriteAt(XSt+40,YSt+24,VraagDoneFg,VraagDoneBg,pijlleft+' 2. '+keuze2+' '+pijlRight);
    if keuze=3 then ZetPijl else clearpijl;
    OverwriteAt(XSt+40,YSt+36,VraagDoneFg,VraagDoneBg,pijlleft+' 3. '+keuze3+' '+pijlRight);
    if keuze=4 then ZetPijl else clearpijl;
    OverwriteAt(XSt+40,YSt+48,VraagDoneFg,VraagDoneBg,pijlleft+' 4. '+keuze4+' '+pijlRight);
    MoveTo(XSt,YSt+60);

  end;


FUNCTION DirExists(dir : dirstr) : boolean;

  var

    rommelrec : searchrec;

  begin

    if dir[length(dir)]='\' then dir[0]:=chr(ord(dir[0])-1);
    Findfirst(dir,directory,rommelrec);
    if doserror<>0 then DirExists:=false else direxists:=true;

  end;


FUNCTION VraagJaNee(Tekst : string; voorkeur : boolean) : boolean;

  var

    X,XL,Y : integer;
    stop : boolean;
    keuze : boolean;

  begin

    MoveUp;
    X:=GetX;
    Y:=GetY;
    OverWriteAt(X,Y,VraagFg,VraagBg,Tekst);
    XL:=X+length(tekst)*8+2;
    stop:=false;
    keuze:=voorkeur;
    repeat
      If keuze then OverWriteAt(XL,Y,VraagFg,VraagBg,'Ja ') else OverWriteAt(XL,Y,VraagFg,VraagBg,'Nee');
      case readkey of
        #13 : stop:=true;
        #27 : ;
        #0  : begin
              if readkey='' then ;
              keuze:=not(keuze);
              end;
        else keuze:=not keuze;
        end;
    until stop;
    OverWriteAt(X,Y,VraagDoneFg,VraagDoneBg,Tekst);
    If keuze
      then OverWriteAt(XL,Y,VraagDoneFg,VraagDoneBg,'Ja ')
      else OverWriteAt(XL,Y,VraagDoneFg,VraagDoneBg,'Nee');
    MoveTo(X,Y+12);
    VraagJaNee:=keuze;

  end;


{$F+}
FUNCTION HeapFunc(Size: word): Integer;

  BEGIN

    if size<>0 then
       begin
       closegraph;
       Writeln('Je programma neemt me net iets te veel geheugen, sorry ...');
       halt;
       end;

  END;
{$F-}


FUNCTION VraagString(maxlengte : byte) : string;

  var

    XPos : byte;
    OScreenpos : word;
    oxpos : byte;
    ScreenPos : word;
    Str : string;
    temp : word;
    teken : char;
    stop : boolean;
    XStart, YStart : word;
    onderline : integer;

  procedure RedrawTextAt(stg : string; XPos : word);

    begin

      bar(Xpos,YStart,XStart+maxlengte*8+10,YStart+9);
      OutTextXy(Xpos,Ystart+2,stg);

    end;


  begin

    XStart:=GetX;
    YStart:=GetY;
    Onderline:=YStart+11;
    Str:='';
    Xpos:=1;
    oxpos:=1;
    stop:=false;
    Screenpos:=1+XStart;
    oscreenpos:=screenpos-1;
    SetFillStyle(1,VraagBg);
    Bar(XStart,YStart,XStart+MaxLengte*8+10,ystart+11);
    SetColor(VraagFg);
    repeat
      teken:=readkey;
      case teken of
        #0 : begin
             case readkey of
               #83 : begin
                     if xpos<=length(str) then
                       begin
                       delete(str,xpos,1);
                       RedrawTextAt(Copy(str,xpos,length(str)-xpos+1),screenpos)
                       end;
                     end;
               #75 : {links}
                     begin
                     if xpos>1 then
                       begin
                       xpos:=xpos-1;
                       screenpos:=screenpos-8;
                       end;
                     end;
               #77 : {rechts}
                     begin
                     if xpos<=length(str) then
                       begin
                       screenpos:=screenpos+8;
                       xpos:=xpos+1;
                       end;
                     end;
               end;
             end;
        #27 : begin
              stop:=true;
              str:='';
              end;
        #8 : begin
             if (xpos=length(str)+1) and (xpos<>1)
               then
                 begin
                 temp:=screenpos;
                 Xpos:=xpos-1;
                 screenpos:=screenpos-textwidth(str[xpos]);
                 Bar(screenpos,YStart,temp,ystart+TextHeight(str[xpos]));
                 dec(str[0]);
                 end
               else
                 begin
                 if xpos>1 then
                   begin
                   Xpos:=xpos-1;
                   screenpos:=screenpos-textwidth(str[xpos]);
                   delete(str,xpos,1);
                   RedrawTextAt(copy(str,xpos,length(str)-xpos+1)+' ',Screenpos);
                   end;
                 end;
             end;
        #13 : stop:=true;
        else
          begin
          insert(teken,str,Xpos);
          if Xpos=length(str)
            then OutTextXY(ScreenPos,YStart+2,teken)
            else RedrawTextAt(copy(str,xpos,length(str)-xpos+1),ScreenPos);
          Screenpos:=screenpos+textWidth(teken);
          Xpos:=XPos+1;
          end;
        end;
      if Oxpos<>Xpos then
        begin
        if oxpos<>0 then
          begin
          Setcolor(VraagBg);
          if oxpos<=length(str)
            then Line(OScreenpos,onderline,OScreenpos+TextWidth(str[OXpos]),onderline)
            else Line(OScreenpos,onderline,OScreenpos+TextWidth(' '),onderline)
          end;
        SetColor(VraagFg);
        if Xpos>length(str)
          then line(Screenpos,onderline,screenpos+TextWidth(' '),onderline)
          else line(Screenpos,onderline,screenpos+TextWidth(str[xpos]),onderline);
        OScreenpos:=screenpos;
        OXpos:=XPos;
        end;
    until stop;
    VraagString:=str;

  end;

PROCEDURE PrintFilesNaarPrinter(titel : string);

  var

    vilelist : pvilelist;
    X,Y : integer;

  begin

    MoveUp;
    X:=getx;
    Y:=getY;
    Overwriteat(X,Y,VraagFg,VraagBg,Titel);
    Vilelist:=new(PVilelist,init(Y+24,Getmaxy));
    While not Vilelist^.gedaan do
      begin
      VileList^.MaakSelection;
      If Not VileList^.gedaan Then Printcopy(VileList^.Pad);
      End;
    Dispose(Vilelist,Done);
    Overwriteat(X,Y,VraagDoneFg,VraagDoneBg,Titel);
    Moveto(X,Y+12);

  end;


FUNCTION GetOneFile(titel : string) : pathstr;

  var

    Vilelist : pvilelist;
    X,Y : integer;

  begin

    MoveUp;
    X:=getx;
    Y:=getY;
    Overwriteat(X,Y,VraagFg,VraagBg,Titel);
    Vilelist:=new(PVilelist,init(Y+24,Getmaxy));
    VileList^.MaakSelection;
    If Not VileList^.gedaan
      Then GetOneFile:=VileList^.Pad
      else GetOneFile:='';
    Dispose(Vilelist,Done);
    Overwriteat(X,Y,VraagDoneFg,VraagDoneBg,Titel);
    Moveto(X,Y+12);

  end;


FUNCTION Vraagstr(Tekst : string) : string;

  var

    answer : string;
    X,Y : integer;

  begin

    MoveUp;
    X:=getx;
    Y:=gety;
    OverwriteAt(X,Y,VraagFg,VraagBg,tekst);
    MoveTo(X+length(tekst)*8+2,Y);
    answer:=Vraagstring(getmaxx-getx div 8);
    SetFillstyle(solidfill,vraagdonebg);
    Bar(X,Y,getmaxx,Y+11);
    OverWriteat(X,Y,vraagdonefg,vraagdonebg,tekst+answer);
    Moveto(X,Y+12);
    vraagstr:=answer;

  end;


FUNCTION VraagInteger(tekst : String; van, tot : Integer) : Integer;

  var

    fout : Integer;
    invoerString : String;
    waarde : Integer;
    gadoor : Boolean;
    XLeft : integer;

  BEGIN

    MoveUp;
    XLeft:=GetX;
    REPEAT
      GaDoor:=true;
      OverwriteAt(XLeft,GetY,VraagFg,VraagBg,Tekst);
      MoveTo(XLeft+length(tekst)*8+2,GetY);
      Invoerstring:=VraagString(3);
      val(invoerString,waarde,fout);
      IF fout<>0 THEN
        BEGIN
        ErrorAt(XLeft,GetY+12,'Je doet iets fout...');
        Gadoor:=false;
        waarde:=van;
        END;
      IF not((waarde>=van) and (waarde<=tot)) THEN
        BEGIN
        Errorat(XLeft,GetY+12,'Het getal moet tussen '+Int2Str(van)+' en '+Int2str(tot)+' liggen !');
        Gadoor:=false;
        END;
    UNTIL gadoor;
    SetFillStyle(Solidfill,VraagDoneBg);
    Bar(XLeft,GetY,XLeft+length(tekst)*8+36,GetY+11);
    SetColor(VraagDoneFg);
    OutTextXy(XLeft+1,GetY+2,Tekst+Int2str(waarde));
    MoveTo(XLeft,GetY+12);
    vraaginteger:=waarde;

  END;


PROCEDURE SwitchMono;

  begin

    Desktop := 0;
    ErrorFg := 1;
    ErrorBg := 0;
    VraagFg := 0;
    VraagBg := 1;
    VraagDoneFg := 1;
    VraagDoneBg := 0;
    Rand := 1;
    FileFg := 1;
    FileBg := 0;
    SelFileFg := 0;
    SelFileBg := 1;
    InfoBg := 1;
    InfoFg := 0;
    Diagrammen := 1;

  end;


BEGIN

  ProgrammaHoofding:='';
  HeapError:=@Heapfunc;

END.