UNIT Printer2;


                                INTERFACE


USES

  Crt,
  Dos;


CONST

{Epson constanten}
 WagenTerug = #13;
 LineFeed   = #10;
 Return     = Wagenterug+lineFeed;
 Escape     = #27;
 EnkeleDichtheid      = #27'K';
 DubbeleDichtheid     = #27'L';
 ViervoudigeDichtheid = #27'Z';
 OnderstreepAan       = #27#45#1;
 OnderstreepUit       = #27#45#0;
 MoveDown             = #27'J';
 EindeBlad            = #12;
 EndOffile            = #26;
 DraftKwaliteit       = Escape+'x'#0;
 LQ                   = Escape+'x'#1;
{HP Deskjet constanten}
 HPOnderstreepAan       = #27#38#100#52#68;
 HPOnderstreepUit       = #27#38#100#64;
 RR300dpi = #27#42#116#51#48#48#82;
 RR150dpi = #27'*t150R';
 RR100dpi = #27'*t100R';
 RR75dpi = #27'*t75R';
 RasterWidth1 = #27#42#114; {hier volgt dan het uiteindelijke getal}
 RasterWidth2 = #83;
 Mode0 = #27#42#98#48#77;
 StartRG = #27#42#114#48#65;
 TransferRG1 = #27#42#98;
 TransferRG2 = #87;
 EndRG = #27'*rB';


VAR

  PrintBestand : file;
  ErIsGeprint  : boolean;
  PrintBestandName : pathstr;


PROCEDURE SluitPrinterBestand;
PROCEDURE WritePrinter(str : string);
PROCEDURE PrintCopy(pad : pathstr);
PROCEDURE ResetPrinter;


                                IMPLEMENTATION

USES

  Algemeen,
  Graph,
  Printer;



VAR

  ErIsOpgestuurd : boolean;
  
  
PROCEDURE MaakPrintBestandName;

  var

    name : pathstr;
    nummer : byte;

  begin

    nummer:=0;
    repeat
      name[0]:=#0;
      str(nummer,name);
      while length(name)<3 do insert('0',name,1);
      insert('PAS2NS.',name,1);
      nummer:=nummer+1;
    until not fileexists(name);
    PrintBestandName:=Name;

  end;


PROCEDURE PrintCopy(pad : pathstr);

  var

    bestand       : file;
    BeginGeheugen : ^char;
    grootte       : longint;
    gelezen       : word;
    geschreven    : word;

  begin

    Assign(bestand,pad);
    erIsGeprint:=true;
    ErisOpgestuurd:=true;
    Reset(bestand,1);
    Grootte:=MaxAvail;
    if grootte>65535 then grootte:=65535;
    GetMem(begingeheugen, grootte);
    repeat
      Blockread(bestand,begingeheugen^,grootte,gelezen);
      Blockwrite(printbestand,begingeheugen^,gelezen,geschreven);
    until (gelezen=0) or (geschreven<gelezen);
    FreeMem(begingeheugen,grootte);
    close(bestand);

  end;


PROCEDURE WritePrinter(str : string);

  begin

    BlockWrite(PrintBestand,str[1],length(str));
    ErIsGeprint:=true;
    ErisOpgestuurd:=true;

  end;


{$F+}
PROCEDURE PrintData;

  VAR

    bestand           : file of char;
    data              : char;
    positie           : longint;
    str               : string;
    grootte           : longint;
    bruikbaar         : boolean;

  PROCEDURE TekenToPrn(teken : char);

    var

      error : word;

    begin

      repeat
        {$I-}
        Write(lst,teken);
        {$I+}
        error:=IOresult;
      until error=0;

    end;


  BEGIN

  If VraagJaNee('Moet ik het nu afprinten ? ',true) then
     begin
     Assign(bestand,PrintBestandName);
     Reset(bestand);
     OverWriteAt(GetX,GetY,InfoFg,InfoBg,'Esc = cancel');
     OverWriteAt(GetX,GetY+12,InfoFg,InfoBg,'Transfering...');
     str:='';
     positie:=0;
     while not(eof(bestand)) and not(positie=74) do
       begin
       read(bestand,data);
       positie:=positie+1;
       str:=str+data;
       end;
     if str='Pas2ns version 1.0 Copyright (C) Werner Van Belle 1992'#13#10 +
     'Print data file'#13#10#26 then Bruikbaar:=true else bruikbaar:=false;
     if bruikbaar then
        begin
        grootte:=filesize(bestand);
        for positie:=75 to grootte do
            begin
            read(bestand,data);
            TekenToPrn(data);
            if keypressed then
               begin
               if readkey=#27 then positie:=grootte;
               while keypressed do if readkey='' then ;
               end;
            end;
        ClrEOL;
        end else ErrorAt(GetX,GetY+24,'Geen pas2ns print data file');
        Close(Bestand);
        end;

  end;


PROCEDURE SluitPrinterBestand;

  begin

    Close(Printbestand);
    if ErIsOpgestuurd
       then PrintData
       else Erase(Printbestand);

  end;
{$F-}


PROCEDURE ResetPrinter;

  begin

    ErIsGeprint:=false;

  end;


BEGIN

  MaakPrintBestandName;
  Assign(PrintBestand,PrintBestandName);
  Rewrite(PrintBestand,1); {de records zijn n byte groot, namelijk n char}
  WritePrinter('Pas2ns version 1.0 Copyright (C) Werner Van Belle 1992'+
  return+'Print data file'+return+EndOfFile);
  ErIsOpgestuurd:=false;
  ResetPrinter;

END.
