UNIT Struct;
{$X+}

                        INTERFACE

USES

    Crt,
    Dos,
    Algemeen,
    Graph,
    StrList,
    GraphLst,
    ReadFile,
    Lijnen,
    Printer2;


TYPE

  PSBlok = ^TSBlok;
  PHoofdingList = ^THoofdingList;
  PStructuur = ^TStructuur;
  PSTructList = ^TStructList;
  PSLList = ^TSLList;
  TSBlok = object
           hoofding : string;
           Structlist : PStructList;
           constructor init;
           procedure Teken;
           PROCEDURE Print(hoogtevanfiguur : word; BR, HR : word);
           END;
  THoofdingList = record
                  hoofding : PStringList;
                  volgende : PHoofdingList;
                  end;
  TSLList = object
            Huidige : PStructList;
            Start   : PStructList;
            SH      : PHoofdingList;
            HH      : PHoofdingList;
            Aantal  : word;
            Hoofding : PStringList;
            constructor init;
            procedure Voegtoe(StructList : PStructList; IH : PStringList);
            procedure Reset;
            function LeesStructList : PStructList;
            end;
  TSoortenstructuren = (SCaseOf, SforNext, SWhileDo, STekst, SRepeatUntil, SIfThenElse);
  TStructuur = object
               Tekst : PStringList;
               Struct1 : PStructList;
               Struct2 : PStructList;
               SLList  : PSLList;
               watishet : TSoortenStructuren;
               volgende : PStructuur;
               constructor init;
               function Breedte : word;
               function Teken(linkermarge, rechtermarge, bovenmarge, doelondermarge : word; tekenen : boolean) : word;
               end;
  TStructlist = object
                StartStructuur : PStructuur;
                Huidige : PStructuur;
                Volgende : PStructList;
                aantal : word;
                constructor init;
                procedure voegtoe(Istructuur : PStructuur);
                procedure reset;
                function LeesStruct : PStructuur;
                function breedte : word;
                function teken(linkermarge, rechtermarge, bovenmarge, doelondermarge : word; tekenen : boolean) : word;
                end;


VAR

  PrintHoofding     : boolean;
  Scherm            : PListGraph;
  StreepDoor        : boolean;
  MinIfThen         : word;
  BreedteResolutie  : word;
  HoogteResolutie   : word;
  RULinkermarge     : word;
  GebruikersNaam    : string;
  GebruikersKlas    : string;
  BNaam             : pathstr;


                             IMPLEMENTATION


CONSTRUCTOR TStructuur.Init;

  begin

    Struct1:=nil;
    Struct2:=nil;
    Tekst:=nil;
    Watishet:=STekst;
    SLList:=nil;

  end;


FUNCTION TStructuur.Breedte : word;

  var

    teller1 : word;
    teller2 : word;
    SL      : PStructList;

  begin

    case watishet of
      STekst : Breedte:=8+8*Tekst^.MaxLengte;
      SIfThenElse : begin
                    teller1:=Struct1^.Breedte;
                    teller2:=struct2^.Breedte;
                    if (Teller1=0) and (Teller2<>0) then
                       begin
                       Breedte:=Teller2+(teller2 div 2)+8;
                       exit;
                       end;
                    if (teller1<>0) and (teller2=0) then
                       begin
                       breedte:=teller1+(teller1 div 2) +8;
                       exit;
                       end;
                    teller1:=teller1+teller2;
                    if teller1=0
                      then breedte:=minifthen
                      else breedte:=teller1;
                    end;
      SRepeatUntil, SWhileDo, SForNext :
                    begin
                    teller1:=Struct1^.Breedte+RULinkermarge;
                    teller2:=8+8*Tekst^.maxlengte;
                    if teller1>=teller2 then breedte:=teller1 else breedte:=teller2;
                    end;
      SCaseOf : begin
                teller1:=0;
                SLList^.reset;
                for teller2:=1 to SLList^.aantal do
                  begin
                  SL:=SLList^.LeesStructList;
                  if SL^.Breedte<10 then teller1:=teller1+10 else
                  teller1:=teller1+SL^.Breedte;
                  end;
                breedte:=teller1;
                end;
      end;

  end;


FUNCTION TStructuur.Teken(linkermarge, rechtermarge, bovenmarge, doelondermarge : word; tekenen : boolean) : word;

  var

    ondermarge   : word;
    linkerlijn   : TLijn;
    Rechterlijn  : TLijn;
    teller1      : word;
    TSL          : PStructList;
    real1        : real;
    teller       : word;
    teller2      : word;
    teller3      : word;
    stop         : boolean;
    str          : Pstring;
    snijpunt     : word;

  function ZetV(L, R, S, B : word) : word;

    var

      T1,T2,T3 : word;

    begin

      stop:=false;
      while not stop do
        begin
        stop:=true;
        Linkerlijn.assign(L,B,S,B+Tekst^.aantalregels*22+16);
        RechterLijn.assign(R,B,S,B+Tekst^.aantalregels*22+16);
        T1:=0;
        tekst^.reset;
        repeat
          T1:=T1+1;
          T2:=(Rechterlijn.XopY(B+4+11*T1)-linkerlijn.XopY(B+4+11*T1)-8) div 8;
          if T2<length(tekst^.leesstring^) then
            begin
            Tekst^.reset;
            for T3:=1 to T1 do tekst^.ZetStringNaar(T2);
            stop:=false;
            end;
        until (not stop) or (T1=tekst^.Aantalregels)
        end;
      if tekenen then
         begin
         with linkerlijn do Scherm^.line(X1,Y1,X2,Y2);
         with rechterlijn do Scherm^.Line(X1,Y1,X2,Y2);
         tekst^.reset;
         for T1:=1 to tekst^.aantalregels do
             begin
             str:=tekst^.leesstring;
             T2:=Rechterlijn.XopY(B+4+T1*11)-Linkerlijn.XopY(B+4+T1*11);
             scherm^.OutTextXY((Linkerlijn.XopY(B+4+T1*11)+((T2 - length(str^)*8) div 2)),
             B+4+T1*11-11, str);
             end;
         end;
      ZetV:=B+Tekst^.aantalregels*22+16;

  end;


  function ZetTekst(L,R,B,DOM: word; welke : PStringList) : word;

    var

      O : word;
      teller1 : word;
      teller2 : word;

    begin

      teller2:=(R-L-8) div 8;
      if teller2<welke^.MaxLengte then
          begin
          welke^.reset;
          teller1:=0;
          repeat
            teller1:=teller1+1;
            welke^.ZetStringNaar(teller2);
          until teller1=welke^.AantalRegels;
          end;
      if tekenen then
         begin
         welke^.Reset;
         for teller1:=1 to welke^.Aantalregels do scherm^.OutTextXY(L+5,B-4+teller1*11,welke^.LeesString);
         end;
      O:=B+8+11*welke^.AantalRegels;
      if DOM>O then O:=DOM;
      if O<19 then O:=19;
      ZetTekst:=O;

    end;

  begin

    case watishet of
      STekst : begin
               ondermarge:=zettekst(linkermarge,rechtermarge,bovenmarge,doelondermarge,tekst);
               if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,ondermarge);
               end;
      SIfThenElse : begin
                    teller2:=rechtermarge-linkermarge;
                    teller1:=struct1^.breedte+Struct2^.breedte;
                    if teller1=0 then real1:=0.5 else real1:=struct1^.breedte/teller1;
                    if real1<0.33 then real1:=0.33;
                    if real1>0.66 then real1:=0.66;
                    teller1:=trunc(real1*teller2);
                    snijpunt:=linkermarge+teller1;
                    ondermarge:=ZetV(linkermarge,rechtermarge,snijpunt,bovenmarge);
                    bovenmarge:=ondermarge;
                    if tekenen then
                       begin
                       Scherm^.Rectangle(linkerlijn.X1,linkerlijn.Y1,rechterlijn.X1,rechterlijn.Y2);
                       Scherm^.OutTextXY(linkermarge+5,ondermarge-11,PTRUE);
                       Scherm^.OutTextXY(rechtermarge-44,ondermarge-11,PFALSE);
                       end;
                    teller1:=bovenmarge+Struct1^.teken(linkermarge,snijpunt, 0, 0, false);
                    teller2:=bovenmarge+Struct2^.teken(snijpunt,rechtermarge, 0, 0, false);
                    if (doelondermarge>teller1) or (doelondermarge>teller2) then ondermarge:=doelondermarge;
                    if teller1>ondermarge then ondermarge:=teller1;
                    if teller2>ondermarge then ondermarge:=teller2;
                    Struct1^.Teken(linkermarge,snijpunt,bovenmarge,ondermarge, tekenen);
                    Struct2^.Teken(snijpunt,rechtermarge,bovenmarge,ondermarge, tekenen);
                    end;
      SRepeatUntil : begin
                     ondermarge:=struct1^.teken(linkermarge+RULinkermarge,rechtermarge,bovenmarge,0, tekenen);
                     ondermarge:=ZetTekst(linkermarge,rechtermarge,ondermarge,doelondermarge,tekst);
                     if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,ondermarge);
                     end;
      SWhileDo : begin
                 ondermarge:=ZetTekst(linkermarge, rechtermarge, bovenmarge,0,tekst);
                 ondermarge:=Struct1^.teken(linkermarge+RULinkermarge,rechtermarge,ondermarge,doelondermarge, tekenen);
                 if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,ondermarge);
                 end;
      SForNext : begin
                 ondermarge:=ZetTekst(linkermarge,rechtermarge,bovenmarge,0,tekst);
                 Ondermarge:=Struct1^.teken(linkermarge+RULinkermarge,rechtermarge,ondermarge,0, tekenen);
                 Ondermarge:=ondermarge+19;
                 if tekenen then Scherm^.OutTextXY(linkermarge+5,ondermarge-11-2,PHerhaal);
                 if ondermarge<doelondermarge then ondermarge:=doelondermarge;
                 if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,ondermarge);
                 end;
      SCaseOf : begin
                teller1:=rechtermarge-linkermarge;
                real1:=(teller1/SLList^.Aantal);
                SLList^.reset;
                for teller:=1 to SLList^.aantal do SLList^.LeesStructList;
                if (SLList^.hoofding^.start<>nil) and (SLList^.Hoofding^.start^.str='ELSE') then
                ondermarge:=ZetV(linkermarge,rechtermarge,round(linkermarge+real1*(SLList^.aantal-1)), bovenmarge)
                else ondermarge:=ZetV(linkermarge,rechtermarge,rechtermarge,bovenmarge);
                SLList^.reset;
                teller3:=0;
                for teller:=1 to SLList^.aantal do
                  begin
                  TSL:=SLList^.LeesStructList;
                  teller1:=round(linkermarge+real1*(teller-1));
                  teller2:=round(linkermarge+real1*teller);
                  teller1:=Zettekst(teller1, teller2 , ondermarge, 0, SLList^.hoofding);
                  if teller1>teller3 then teller3:=teller1;
                  end;
                ondermarge:=teller3;
                if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,ondermarge);
                bovenmarge:=ondermarge;
                SLList^.reset;
                for teller:=1 to SLList^.aantal do
                  begin
                  TSL:=SLList^.LeesStructList;
                  teller1:=round(linkermarge+real1*(teller-1));
                  teller2:=round(linkermarge+real1*teller);
                  if tekenen then
                     begin
                     if teller<SLList^.aantal then Scherm^.Line(teller2,linkerlijn.YopX(teller2),teller2,bovenmarge);
                     end;
                  if TSL^.teken(teller1,teller2,0,0,false)+bovenmarge>doelondermarge then
                  doelondermarge:=bovenmarge+TSL^.teken(teller1,teller2,0,0,false);
                  end;
                ondermarge:=doelondermarge;
                SLList^.reset;
                for teller:=1 to SLList^.aantal do
                  begin
                  TSL:=SLList^.LeesStructList;
                  TSL^.teken(round(linkermarge+(teller-1)*real1),round(linkermarge+teller*real1),bovenmarge,
                  ondermarge, tekenen);
                  end;
                end;
      end;
    Teken:=OnderMarge;

  end;
  

CONSTRUCTOR TStructList.Init;

  begin

    StartStructuur:=nil;
    Huidige:=nil;
    aantal:=0;

  end;


FUNCTION TStructList.Breedte : word;

  var

    Hudige : PStructuur;
    waarde : word;
    teller : word;

  begin

    Hudige:=startstructuur;
    waarde:=0;
    while hudige<>nil do
       begin
       teller:=hudige^.breedte;
       if teller>waarde then waarde:=teller;
       Hudige:=hudige^.volgende;
       end;
    Breedte:=Waarde;

  end;


PROCEDURE TStructList.VoegToe(IStructuur : PStructuur);

  var

    locale : PStructuur;

  begin

    if Startstructuur=nil
       then
         begin
         New(StartStructuur);
         Startstructuur:=IStructuur;
         StartStructuur^.volgende:=nil;
         end
       else
         begin
         locale:=Startstructuur;
         while not(locale^.volgende=nil) do locale:=locale^.volgende;
         new(locale^.volgende);
         locale^.volgende:=IStructuur;
         locale^.volgende^.volgende:=nil;
         end;
    aantal:=aantal+1;

  end;


PROCEDURE TStructList.Reset;

  begin

    Huidige:=StartStructuur;

  end;


FUNCTION TStructList.LeesStruct : PStructuur;

  begin

    if huidige<>nil then
       begin
       LeesStruct:=Huidige;
       Huidige:=huidige^.volgende;
       end;

  end;

FUNCTION TStructList.Teken(linkermarge, rechtermarge, bovenmarge, doelondermarge : word; tekenen : boolean) : word;

  var

    teller : word;

  begin

    reset;
    if aantal=0 then
       begin
       if doelondermarge>bovenmarge then
          begin
          if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,doelondermarge);
          if tekenen and streepdoor then Scherm^.Line(linkermarge,bovenmarge,rechtermarge,doelondermarge);
          bovenmarge:=doelondermarge;
          end
       else
          begin
          if tekenen then Scherm^.Rectangle(linkermarge,bovenmarge,rechtermarge,bovenmarge+19);
          if tekenen and streepdoor then Scherm^.Line(linkermarge,bovenmarge,rechtermarge,bovenmarge+19);
          bovenmarge:=bovenmarge+19;
          end;
       end;
    for teller:=1 to aantal do
      begin
        if teller=aantal
           then bovenmarge:=Tstructlist.LeesStruct^.Teken(Linkermarge, Rechtermarge, bovenmarge, doelondermarge, tekenen)
           else bovenmarge:=Tstructlist.LeesStruct^.Teken(Linkermarge, Rechtermarge, bovenmarge, 0, tekenen);
      end;
    teken:=bovenmarge;

  end;


constructor TSLList.init;

  begin

    Aantal:=0;
    hoofding:=nil;
    Huidige:=nil;
    start:=nil;
    SH:=nil;
    HH:=nil;

  end;


procedure TSLList.Voegtoe(structlist : PStructlist; IH : PStringList);

  var

    locale : PStructList;
    LH     : PHoofdingList;

  begin

    locale:=start;
    LH:=SH;
    if aantal=0 then
        begin
        Start:=StructList;
        Start^.volgende:=nil;
        new(SH);
        SH^.hoofding:=IH;
        SH^.volgende:=nil;
        end
      else
        begin
        while locale^.volgende<>nil do
          begin
          locale:=locale^.volgende;
          LH:=LH^.volgende;
          end;
        locale^.volgende:=StructList;
        locale^.volgende^.volgende:=nil;
        new(LH^.volgende);
        LH^.volgende^.volgende:=nil;
        LH^.volgende^.hoofding:=IH;
        end;
    aantal:=aantal+1;

  end;


PROCEDURE TSLList.Reset;

  begin

    Huidige:=start;
    HH:=SH;

  end;


FUNCTION TSLList.LeesStructList : PStructlist;

  begin

    LeesStructList:=huidige;
    hoofding:=HH^.hoofding;
    if huidige<>nil then
      begin
      huidige:=huidige^.volgende;
      HH:=HH^.volgende;
      end;

  end;


CONSTRUCTOR TSBlok.Init;

  begin

    Structlist:=nil;

  end;


PROCEDURE TSBlok.Print(hoogtevanfiguur : word; BR, HR : word);

  begin

    Scherm^.Print(HoogteVanFiguur, BR, HR);

  end;


PROCEDURE TSBlok.Teken;

  var

    waarde          : word;
    teller          : word;
    linkermarge     : word;
    rechtermarge    : word;
    bovenmarge      : word;
    X, Y            : integer;
    stop            : boolean;
    aanvaard        : boolean;
    DX              : integer;
    OX              : integer;
    OY              : integer;
    DY              : integer;
    hoogteVanFiguur : word;


  begin

    new(Scherm,init);
    bovenmarge:=0;
    if printhoofding then
       begin
       Scherm^.OutTextXY(0,0,@Hoofding);
       Bovenmarge:=11;
       end;
    LinkerMarge:=0;
    RechterMarge:=StructList^.Breedte;
    if hp
      then
        begin
        if (breedteresolutie=1) and (rechtermarge>585) then rechtermarge:=585;
        if (breedteresolutie=2) and (rechtermarge>788) then rechtermarge:=788;
        if (breedteresolutie=3) and (rechtermarge>1182) then rechtermarge:=1182;
        if (breedteresolutie=4) and (rechtermarge>1918) then rechtermarge:=1918;
        end
      else
        begin
        if (breedteresolutie=1) and (rechtermarge>479) then rechtermarge:=479;
        if (breedteresolutie=2) and (rechtermarge>959) then rechtermarge:=959;
        if (breedteresolutie=3) and (rechtermarge>1919) then rechtermarge:=1919;
        end;
    HoogteVanFiguur:=structlist^.teken(linkermarge, rechtermarge, bovenmarge, 0, true);
    X:=0;
    OX:=10;
    Y:=0;
    OY:=10;
    stop:=false;
    DX:=(getmaxX div 2);
    DY:=(getmaxY div 2);
    MakeScreen;
    repeat
      if (X<>OX) or (Y<>OY) then
         begin
         Setcolor(Diagrammen);
         MakeScreen;
         Scherm^.teken(X,Y);
         OX:=X;
         OY:=Y;
         end;
      case readkey of
        #13 : begin
              aanvaard:=true;
              stop:=true;
              end;
        #27 : begin
              aanvaard:=false;
              stop:=true;
              end;
        #0 : begin
             case readkey of
               #45 : halt;
               #75 : begin
                     X:=X+DX;
                     If X>0 then X:=0;
                     end;
               #77 : begin
                     X:=X-DX;
                     if abs(X)>rechtermarge then X:=-rechtermarge;
                     end;
               #80 : begin
                     Y:=Y-DY;
                     if abs(Y)>hoogtevanfiguur then Y:=-hoogtevanfiguur;
                     end;
               #72 : begin
                     Y:=Y+DY;
                     if Y>0 then Y:=0;
                     end;
               #71 : begin
                     X:=0;
                     Y:=0;
                     end;
               end;
             end;
        end;
    until stop;
    MakeScreen;
    If Aanvaard Then
      begin
      OverWriteAt(DX-45,DY-4,InfoFg,InfoBg,'Printing...');
      Print(HoogteVanFiguur,BreedteResolutie, HoogteResolutie);
      end;

  end;


BEGIN

  BreedteResolutie:=2;
  HoogteResolutie:=2;
  StreepDoor:=false;
  RULinkermarge:=20; {De Repeat-Until Linkermarge}
  MinIfThen:=200;
  Scherm:=nil;
  Printhoofding:=false;
  GebruikersNaam:='';
  GebruikersKlas:='';
  BNaam:='';

END.
